(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    173738,       5967]
NotebookOptionsPosition[    123072,       4399]
NotebookOutlinePosition[    153068,       5282]
CellTagsIndexPosition[    151795,       5232]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell["Introductory Tutorial", "Title",
 CellTags->"c:1"],

Cell["Basic tools in QDENSITY", "Subtitle"],

Cell[TextData[{
 "Version: 3.0-April 2011--For ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 6.0-8.0"
}], "Abstract",
 CellChangeTimes->{{3.395090887981901*^9, 3.395090925377634*^9}, {
  3.5122043095457993`*^9, 3.512204334243861*^9}, {3.512204716872068*^9, 
  3.512204717487535*^9}}],

Cell[CellGroupData[{

Cell["\<\
Getting started                To  open   double   click at down arrow  \
--------------------------->>\
\>", "Section",
 CellChangeTimes->{{3.5122044149751883`*^9, 3.512204420963462*^9}, {
  3.512204654694922*^9, 3.512204703295166*^9}},
 FontFamily->"Times",
 CellTags->{"c:2", "b:5.0"}],

Cell[TextData[{
 StyleBox["All the codes simulating quantum circuits will start by loading \
the ",
  FontFamily->"Helvetica"],
 "QDENSITY",
 StyleBox[" package.\nTo make the package fully available copy the QDENSITY \
directory to this location on \nyour user account:",
  FontFamily->"Helvetica"]
}], "Text",
 TextJustification->0,
 FontFamily->"Courier New",
 CellTags->"b:5.0"],

Cell[BoxData[
 RowBox[{"ToFileName", "[", " ", 
  RowBox[{"{", 
   RowBox[{"$UserBaseDirectory", ",", " ", "\"\<Applications\>\""}], "}"}], 
  "]"}]], "Input",
 CellTags->"b:5.0"],

Cell[TextData[StyleBox["Then you can load the package by using:",
 FontFamily->"Helvetica"]], "Text",
 TextJustification->0,
 FontFamily->"Courier New",
 CellTags->"b:5.0"],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<QDENSITY`Qdensity`\>\"", "]"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:5.0"],

Cell[TextData[StyleBox["To see all the commands contained in the package:  ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.0"],

Cell[BoxData[
 RowBox[{"?", "QDENSITY`Qdensity`*"}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:5.0"],

Cell[TextData[StyleBox["If you click on any entry in the display above, \
information about it will appear above this line.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"?", "intro"}]], "Input",
 CellTags->"b:5.0"],

Cell[BoxData[
 RowBox[{"?", "about"}]], "Input",
 CellTags->"b:5.0"]
}, Open  ]],

Cell[TextData[{
 StyleBox["You can access the package Palette by clicking here: ",
  FontFamily->"Helvetica"],
 ButtonBox["QDENSpalette.nb",
  BaseStyle->"Hyperlink",
  ButtonData:>{"QDENSpalette.nb", None}]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.0"]
}, Closed]],

Cell[CellGroupData[{

Cell["Basic operations", "Section",
 FontFamily->"Times",
 CellTags->"c:3"],

Cell[CellGroupData[{

Cell["a) Single qubit states", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"SingleQubitStates", "c:4", "b:5.1.0"}],

Cell[TextData[{
 StyleBox["The initial state of the system is represented by a density \
matrix. A ",
  FontFamily->"Helvetica"],
 StyleBox["one qubit state ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["in the |0\[RightAngleBracket] state has the density matrix:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.0"],

Cell[BoxData[
 SubscriptBox["\[ScriptCapitalP]", "0"]], "Input",
 CellTags->"b:5.1.0"],

Cell[TextData[StyleBox["This is also the single qubit  projection operator  \
|0\[RightAngleBracket]\[LeftAngleBracket]0| .",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.0"],

Cell[TextData[StyleBox[" ... in the |1\[RightAngleBracket] state...",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.0"],

Cell[BoxData[
 SubscriptBox["\[ScriptCapitalP]", "1"]], "Input",
 CellTags->"b:5.1.0"],

Cell[TextData[StyleBox["This is also the single qubit  projection operator  \
|1\[RightAngleBracket]\[LeftAngleBracket]1| .",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.0"],

Cell[TextData[StyleBox[" Alternatively we can define the states and \
associated density matrix making use of predefined Ket and Bra state vectors",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.0"],

Cell[BoxData[
 RowBox[{"Ket", "[", "0", "]"}]], "Input",
 CellTags->{"i:4", "b:5.1.0"}],

Cell[BoxData[
 RowBox[{"Bra", "[", "1", "]"}]], "Input",
 CellTags->{"i:3", "b:5.1.0"}],

Cell[TextData[{
 StyleBox[" And so, one can build ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[ScriptCapitalP]", "0"], TraditionalForm]]],
 StyleBox["using the ",
  FontFamily->"Helvetica"],
 StyleBox["tensor product",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" \[CircleTimes]",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Ket", "[", "0", "]"}], "\[CircleTimes]", 
  RowBox[{"Bra", "[", "0", "]"}]}]], "Input",
 CellTags->"b:5.1.0"],

Cell[TextData[StyleBox[" A more general 1 qubit state written using Ket, ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.0"],

Cell[BoxData[{
 RowBox[{"GenQubit", "=", 
  RowBox[{
   RowBox[{"a", "*", 
    RowBox[{"Ket", "[", "0", "]"}]}], "+", 
   RowBox[{"b", "*", 
    RowBox[{"Ket", "[", "1", "]"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]GenQubit", "=", 
  RowBox[{
   RowBox[{"GenQubit", "\[CircleTimes]", 
    RowBox[{"Adj", "[", "GenQubit", "]"}]}], " ", "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Conjugate", "[", "a", "]"}], "\[Rule]", 
      SuperscriptBox["a", "*"]}], ",", 
     RowBox[{
      RowBox[{"Conjugate", "[", "b", "]"}], "\[Rule]", 
      SuperscriptBox["b", "*"]}]}], "}"}]}]}]}], "Input",
 CellTags->"b:5.1.0"],

Cell[TextData[{
 StyleBox["And we can evaluate the ",
  FontFamily->"Helvetica"],
 StyleBox[" trace and purity  ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["of the above density matrix.",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.0"],

Cell[BoxData[{
 RowBox[{"Tr", "[", "\[Rho]GenQubit", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Purity", "[", "\[Rho]GenQubit", "]"}], "]"}]}], "Input",
 CellTags->"b:5.1.0"],

Cell[TextData[{
 StyleBox["The package contains also definitions for ",
  FontFamily->"Helvetica"],
 StyleBox["|+\[RightAngleBracket] and |-\[RightAngleBracket] states, ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["i.e for states in the plus or minus x-direction",
  FontFamily->"Helvetica",
  FontVariations->{"CompatibilityType"->0}],
 StyleBox[" :",
  FontFamily->"Helvetica",
  FontWeight->"Bold"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.0"],

Cell[BoxData[{
 RowBox[{"KetX", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"KetX", "[", "1", "]"}]}], "Input",
 CellTags->"b:5.1.0"],

Cell[TextData[{
 StyleBox["One can readily check that the above states are eigenstates of ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Sigma]", 
    RowBox[{"1", " "}]], TraditionalForm]]],
 "with eigenvalues 1 and -1 , respectively:"
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   SubscriptBox["\[Sigma]", "1"], ".", 
   RowBox[{"KetX", "[", "0", "]"}]}], " ", "==", " ", 
  RowBox[{"KetX", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   SubscriptBox["\[Sigma]", "1"], ".", 
   RowBox[{"KetX", "[", "1", "]"}]}], " ", "==", 
  RowBox[{"-", 
   RowBox[{"KetX", "[", "1", "]"}]}]}]}], "Input",
 CellTags->"b:5.1.0"],

Cell[TextData[{
 StyleBox["Scalar products",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" are simple to compute; for instance, if we have a general state \
in the computational basis, we can compute its scalar product with the |+\
\[RightAngleBracket] or |-\[RightAngleBracket] operators (KetX[0] and \
KetX[1]):",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.0"],

Cell[BoxData[
 RowBox[{"State1", "=", 
  RowBox[{
   RowBox[{"a", "*", 
    RowBox[{"Bra", "[", "0", "]"}]}], "+", 
   RowBox[{"b", "*", 
    RowBox[{"Bra", "[", "1", "]"}]}]}]}]], "Input",
 CellTags->"b:5.1.0"],

Cell[BoxData[{
 RowBox[{"State1", ".", 
  RowBox[{"KetX", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"State1", ".", 
  RowBox[{"KetX", "[", "1", "]"}]}]}], "Input",
 CellTags->"b:5.1.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["b) MultiQubit states", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:5", "b:5.1.1"}],

Cell[TextData[{
 StyleBox[" Multiqubit states are built as tensor products of single qubit \
ones, for instance, a",
  FontFamily->"Helvetica"],
 StyleBox[" two qubit",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" state as |00\[RightAngleBracket] or |01\[RightAngleBracket] \
corresponds to:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.1"],

Cell[BoxData[{
 RowBox[{"(", 
  RowBox[{
   SubscriptBox["\[ScriptCapitalP]", "0"], "\[CircleTimes]", 
   SubscriptBox["\[ScriptCapitalP]", "0"]}], ")"}], "\[IndentingNewLine]", 
 RowBox[{"(", 
  RowBox[{
   SubscriptBox["\[ScriptCapitalP]", "0"], "\[CircleTimes]", 
   SubscriptBox["\[ScriptCapitalP]", "1"]}], ")"}]}], "Input",
 CellTags->"b:5.1.1"],

Cell[TextData[{
 StyleBox[" The use of the parentheses in the tensor product is essential \
when considering more than two qubits; for instance, the ",
  FontFamily->"Helvetica"],
 StyleBox["three qubit ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["state |011\[RightAngleBracket] corresponds to any of the two \
following forms,",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.1"],

Cell[BoxData[{
 RowBox[{"(", 
  StyleBox[
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[ScriptCapitalP]", 
       StyleBox["0",
        ScriptLevel->0]], "\[CircleTimes]", 
      SubscriptBox["\[ScriptCapitalP]", 
       StyleBox["1",
        ScriptLevel->0]]}], ")"}], "\[CircleTimes]", 
    SubscriptBox["\[ScriptCapitalP]", 
     StyleBox["1",
      ScriptLevel->0]]}],
   ScriptLevel->0], 
  StyleBox[")",
   ScriptLevel->0]}], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"(", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", 
     StyleBox["0",
      ScriptLevel->0]], "\[CircleTimes]", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[ScriptCapitalP]", 
       StyleBox["1",
        ScriptLevel->0]], "\[CircleTimes]", 
      SubscriptBox["\[ScriptCapitalP]", 
       StyleBox["1",
        ScriptLevel->0]]}], ")"}]}], ")"}],
  ScriptLevel->0]}], "Input",
 CellTags->"b:5.1.1"],

Cell[TextData[StyleBox["Using the BraKet notation we could build a three \
qubit state such as, [NOTE KetX[0] and KetX[1] are the eigenstates of SigmaX, \
the parentheses are again essential]",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.1"],

Cell[BoxData[
 RowBox[{"ket123", " ", "=", " ", 
  RowBox[{
   RowBox[{"Ket", "[", "0", "]"}], "\[CircleTimes]", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Ket", "[", "1", "]"}], "\[CircleTimes]", 
     RowBox[{"KetX", "[", "1", "]"}]}], ")"}]}]}]], "Input",
 CellTags->"b:5.1.1"],

Cell[TextData[StyleBox["... and build its back to back density matrix out of \
it, ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.1"],

Cell[BoxData[
 RowBox[{"\[Rho]123", "=", 
  RowBox[{"ket123", "\[CircleTimes]", 
   RowBox[{"Adj", "[", "ket123", "]"}]}]}]], "Input",
 CellTags->"b:5.1.1"],

Cell[TextData[{
 StyleBox["Then check its ",
  FontFamily->"Helvetica"],
 StyleBox["Trace and Purity",
  FontFamily->"Helvetica",
  FontWeight->"Bold"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.1"],

Cell[BoxData[{
 RowBox[{"Tr", "[", "\[Rho]123", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Purity", "[", "\[Rho]123", "]"}]}], "Input",
 CellTags->"b:5.1.1"],

Cell[TextData[StyleBox["For states in the computational bases we can use \
alternatively the function KetV[List] and BraV[List]:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.1"],

Cell[BoxData[
 RowBox[{"KetV", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "1", ",", "1"}], "}"}], "]"}]], "Input",
 CellTags->"b:5.1.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"4", "*", 
   RowBox[{"BraV", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], "]"}]}], 
  " ", "+", " ", 
  RowBox[{"BraV", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "0", ",", "1"}], "}"}], "]"}], "+", 
  RowBox[{"A", "*", 
   RowBox[{"BraV", "[", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", "0", ",", "1", ",", "1"}], "}"}], 
    "]"}]}]}]], "Input",
 CellTags->"b:5.1.1"],

Cell[TextData[StyleBox["For example, the following expressions give the same \
output: ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"KetV", "[", 
   RowBox[{"{", "0", "}"}], "]"}], "\[Equal]", 
  RowBox[{"Ket", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"KetV", "[", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"Ket", "[", "0", "]"}], "\[CircleTimes]", 
   RowBox[{"Ket", "[", "1", "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"KetV", "[", 
   RowBox[{"{", 
    RowBox[{"0", ",", "a", ",", "b"}], "}"}], "]"}], "\[Equal]", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Ket", "[", "0", "]"}], "\[CircleTimes]", 
     RowBox[{"Ket", "[", "a", "]"}]}], ")"}], "\[CircleTimes]", 
   RowBox[{"Ket", "[", "b", "]"}]}]}]}], "Input",
 CellTags->"b:5.1.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell["c) Bell and GHZ states", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:6", "b:5.1.2"}],

Cell[TextData[StyleBox[" Relevant two and three qubit states are the Bell \
states and the GHZ state. ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.2"],

Cell[TextData[{
 StyleBox["The ",
  FontFamily->"Helvetica"],
 StyleBox["Bell states",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" are the following:\n",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "00"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |00\[RightAngleBracket] + |11\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "01"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |01\[RightAngleBracket] + |10\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "10"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |00\[RightAngleBracket] - |11\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "11"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |01\[RightAngleBracket] - |10\[RightAngleBracket] )"
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.2"],

Cell[TextData[StyleBox["They can all be constructed in the following way, \
first we build a Bell operator of the form:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.2"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Bellop", "=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"2", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"2", ",", "1"}], "]"}]}], " "}]}]], "Input",
 CellTags->"b:5.1.2"],

Cell[TextData[StyleBox["Then we build:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.2"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   SubscriptBox["B", 
    RowBox[{"a_", ",", "b_"}]], ":=", 
   RowBox[{"Bellop", ".", 
    RowBox[{"(", 
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalP]", 
        StyleBox["a",
         ScriptLevel->0]], "\[CircleTimes]", 
       SubscriptBox["\[ScriptCapitalP]", 
        StyleBox["b",
         ScriptLevel->0]]}],
      ScriptLevel->0], 
     StyleBox[")",
      ScriptLevel->0]}], ".", 
    StyleBox[
     RowBox[{"Adj", "[", "Bellop", "]"}],
     ScriptLevel->0], " "}]}]}]], "Input",
 CellTags->"b:5.1.2"],

Cell[TextData[{
 StyleBox["These states are of capital importance in quantum circuits. Check \
for instance the Teleportation circuit; click here: ",
  FontFamily->"Helvetica"],
 ButtonBox["Teleportation.nb",
  BaseStyle->"Hyperlink",
  ButtonData:>{"Teleportation.nb", None}]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.2"],

Cell[TextData[{
 StyleBox["The ",
  FontFamily->"Helvetica"],
 StyleBox["GHZ state",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" may be prepared by acting on a state with three qubits all  \
initialized to 0 with the following operator:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GHZop", "=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "1", ",", "3"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"3", ",", "1"}], "]"}]}]}], ";"}]], "Input",
 CellTags->"b:5.1.2"],

Cell[TextData[StyleBox["Then the density matrix for this GHZ state  is:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.2"],

Cell[BoxData[
 RowBox[{"\[Rho]GHZ", "=", 
  RowBox[{"GHZop", ".", 
   RowBox[{"(", 
    StyleBox[
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[ScriptCapitalP]", 
         StyleBox["0",
          ScriptLevel->0]], "\[CircleTimes]", 
        SubscriptBox["\[ScriptCapitalP]", 
         StyleBox["0",
          ScriptLevel->0]]}], ")"}], "\[CircleTimes]", 
      SubscriptBox["\[ScriptCapitalP]", 
       StyleBox["0",
        ScriptLevel->0]]}],
     ScriptLevel->0], 
    StyleBox[")",
     ScriptLevel->0]}], 
   StyleBox[".",
    ScriptLevel->0], 
   StyleBox[
    RowBox[{"Adj", "[", "GHZop", "]"}],
    ScriptLevel->0]}]}]], "Input",
 CellTags->"b:5.1.2"],

Cell[TextData[StyleBox["Which is mathematically equivalent to building the \
state and then its density matrix  as:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"GHZvec", "=", 
   RowBox[{
    RowBox[{"1", "/", 
     SqrtBox["2"]}], 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       StyleBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Ket", "[", "0", "]"}], "\[CircleTimes]", 
           RowBox[{"Ket", "[", "0", "]"}]}], ")"}], "\[CircleTimes]", 
         RowBox[{"Ket", "[", "0", "]"}]}],
        ScriptLevel->0], 
       StyleBox[")",
        ScriptLevel->0]}], 
      StyleBox[" ",
       ScriptLevel->0], 
      StyleBox["+",
       ScriptLevel->0], 
      StyleBox[" ",
       ScriptLevel->0], 
      RowBox[{"(", 
       StyleBox[
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Ket", "[", "1", "]"}], "\[CircleTimes]", 
           RowBox[{"Ket", "[", "1", "]"}]}], ")"}], "\[CircleTimes]", 
         RowBox[{"Ket", "[", "1", "]"}]}],
        ScriptLevel->0], 
       StyleBox[")",
        ScriptLevel->0]}]}], 
     StyleBox[")",
      ScriptLevel->0]}]}]}], 
  StyleBox[";",
   ScriptLevel->0]}], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"\[Rho]GHZvec", "=", 
   RowBox[{"GHZvec", "\[CircleTimes]", 
    RowBox[{"Adj", "[", "GHZvec", "]"}]}]}],
  ScriptLevel->0]}], "Input",
 CellTags->"b:5.1.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell["d) Subsystems, partial traces", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:7", "b:5.1.3"}],

Cell[TextData[{
 StyleBox[" The density matrix of a specific subsystem can be computed easily \
by taking partial traces of the density matrix of the full system, e.g. we \
will build the ",
  FontFamily->"Helvetica"],
 StyleBox["4 qubit state ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["|0111\[RightAngleBracket] and then recover the state of either the \
subsystem (1) or the subsystems (24).  For example, starting with a four \
qubit state |0111\[RightAngleBracket], its density matrix is constructed and \
then partial traces taken:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.3"],

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[Rho]", "1234"], "=", 
  RowBox[{"(", 
   StyleBox[
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[ScriptCapitalP]", 
          StyleBox["0",
           ScriptLevel->0]], "\[CircleTimes]", 
         SubscriptBox["\[ScriptCapitalP]", 
          StyleBox["1",
           ScriptLevel->0]]}], ")"}], "\[CircleTimes]", 
       SubscriptBox["\[ScriptCapitalP]", 
        StyleBox["1",
         ScriptLevel->0]]}], ")"}], "\[CircleTimes]", 
     SubscriptBox["\[ScriptCapitalP]", 
      StyleBox["1",
       ScriptLevel->0]]}],
    ScriptLevel->0], 
   StyleBox[")",
    ScriptLevel->0]}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox[
   StyleBox["\[Rho]",
    ScriptLevel->0], "1"], "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "3", ",", "4"}], "}"}], ",", 
    SubscriptBox["\[Rho]", "1234"]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  SubscriptBox["\[Rho]", "24"], "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}], ",", 
    SubscriptBox["\[Rho]", "1234"]}], "]"}]}]}], "Input",
 CellTags->"b:5.1.3"],

Cell[TextData[{
 StyleBox[" We can check basic properties of these density matrices, such as \
their ",
  FontFamily->"Helvetica"],
 StyleBox["length, trace ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["and ",
  FontFamily->"Helvetica"],
 StyleBox["Purity:",
  FontFamily->"Helvetica",
  FontWeight->"Bold"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.3"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Length", "[", 
  SubscriptBox["\[Rho]", "1234"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  SubscriptBox["\[Rho]", "1234"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Purity", "[", 
  SubscriptBox["\[Rho]", "1234"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Length", "[", 
  SubscriptBox["\[Rho]", "24"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  SubscriptBox["\[Rho]", "24"], "]"}]}], "Input",
 CellTags->"b:5.1.3"],

Cell[TextData[StyleBox[" Similarly we can produce a more complicated density \
matrix that is not pure,",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.3"],

Cell[BoxData[
 RowBox[{"a123", "=", 
  RowBox[{
   RowBox[{"1", "/", "3"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      StyleBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["\[ScriptCapitalP]", 
           StyleBox["0",
            ScriptLevel->0]], "\[CircleTimes]", 
          SubscriptBox["\[ScriptCapitalP]", 
           StyleBox["1",
            ScriptLevel->0]]}], ")"}], "\[CircleTimes]", 
        SubscriptBox["\[ScriptCapitalP]", 
         StyleBox["1",
          ScriptLevel->0]]}],
       ScriptLevel->0], 
      StyleBox[")",
       ScriptLevel->0]}], 
     StyleBox["+",
      ScriptLevel->0], 
     RowBox[{"(", 
      StyleBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["\[ScriptCapitalP]", "1"], "\[CircleTimes]", 
          SubscriptBox["\[ScriptCapitalP]", 
           StyleBox["1",
            ScriptLevel->0]]}], ")"}], "\[CircleTimes]", 
        SubscriptBox["\[ScriptCapitalP]", 
         StyleBox["1",
          ScriptLevel->0]]}],
       ScriptLevel->0], 
      StyleBox[")",
       ScriptLevel->0]}], 
     StyleBox["+",
      ScriptLevel->0], 
     RowBox[{"(", 
      StyleBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["\[ScriptCapitalP]", 
           StyleBox["0",
            ScriptLevel->0]], "\[CircleTimes]", 
          SubscriptBox["\[ScriptCapitalP]", "0"]}], ")"}], "\[CircleTimes]", 
        SubscriptBox["\[ScriptCapitalP]", 
         StyleBox["1",
          ScriptLevel->0]]}],
       ScriptLevel->0], 
      StyleBox[")",
       ScriptLevel->0]}]}], 
    StyleBox[")",
     ScriptLevel->0]}]}]}]], "Input",
 CellTags->"b:5.1.3"],

Cell[BoxData[{
 RowBox[{"Tr", "[", "a123", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Purity", "[", "a123", "]"}]}], "Input",
 CellTags->"b:5.1.3"]
}, Open  ]],

Cell[TextData[StyleBox["It is interesting to show the density matrix for each \
qubit taking partial traces. These subspace density matrices can be thought \
of  as the density matrices of qubit i in the environment of the remaining 2 \
qubits:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.3"],

Cell[BoxData[
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", "a123"}], "]"}]], "Input",
 CellTags->"b:5.1.3"],

Cell[BoxData[
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", "a123"}], "]"}]], "Input",
 CellTags->"b:5.1.3"],

Cell[BoxData[
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", "a123"}], "]"}]], "Input",
 CellTags->"b:5.1.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell["e) Pauli Spin matrices", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:8", "b:5.1.4"}],

Cell[TextData[{
 StyleBox[" The ",
  FontFamily->"Helvetica"],
 StyleBox["Pa",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["uli spin matrices ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["are defined in the package and are easily used, ",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.4"],

Cell[BoxData[{
 SubscriptBox["\[Sigma]", "0"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "1"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "2"], "\[IndentingNewLine]", 
 SubscriptBox["\[Sigma]", "3"]}], "Input",
 CellTags->"b:5.1.4"],

Cell[TextData[StyleBox["or alternatively with the notation:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.4"],

Cell[BoxData[{
 RowBox[{"s", "[", "0", "]"}], "\[IndentingNewLine]", 
 RowBox[{"s", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"s", "[", "2", "]"}], "\[IndentingNewLine]", 
 RowBox[{"s", "[", "3", "]"}]}], "Input",
 CellTags->"b:5.1.4"],

Cell[TextData[{
 StyleBox[" ",
  FontFamily->"Helvetica"],
 StyleBox["Pauli spin matrices ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["can be used to build the more general 2 and n qubit desnity \
matrices, e.g. for a ",
  FontFamily->"Helvetica"],
 StyleBox["general 2 qubit state",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" the density matrix",
  FontFamily->"Helvetica",
  FontVariations->{"CompatibilityType"->0}],
 StyleBox[" is:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Rho]AB", " ", "=", " ", 
     RowBox[{
      RowBox[{"Sum", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"1", "/", "4"}], ")"}], "*", 
         RowBox[{"P", "[", 
          RowBox[{"i", ",", "j"}], "]"}], " ", "*", 
         RowBox[{"(", " ", 
          RowBox[{
           SubscriptBox["\[Sigma]", "i"], "\[CircleTimes]", " ", 
           SubscriptBox["\[Sigma]", "j"]}], ")"}]}], ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "0", ",", "3"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "0", ",", "3"}], "}"}]}], "]"}], " ", "/.", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"0", ",", "0"}], "]"}], "\[Rule]", "1"}], ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"1", ",", "0"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "x", "A"]}], " ", ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"2", ",", "0"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "y", "A"]}], ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"3", ",", "0"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "z", "A"]}], ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"0", ",", " ", "1"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "x", "B"]}], " ", ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"0", ",", " ", "2"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "y", "B"]}], ",", 
        RowBox[{
         RowBox[{"P", "[", 
          RowBox[{"0", ",", " ", "3"}], "]"}], "\[Rule]", 
         SubsuperscriptBox["P", "z", "B"]}]}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"1", "/", "4"}], ")"}], "*", 
    RowBox[{"Simplify", "[", 
     RowBox[{"MatrixForm", "[", " ", 
      RowBox[{"4", "*", "\[Rho]AB"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
   RowBox[{"Tr", "[", " ", "\[Rho]AB", "]"}]}]}]], "Input",
 CellTags->"b:5.1.4"],

Cell[TextData[{
 StyleBox[" ",
  FontFamily->"Helvetica"],
 StyleBox["The above",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" density matrix",
  FontFamily->"Helvetica",
  FontVariations->{"CompatibilityType"->0}],
 StyleBox[" is of the form ",
  FontFamily->"Helvetica"],
 " \[Rho]AB",
 StyleBox["= ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    FractionBox["1", "4"], "  ", "[", 
    RowBox[{"1", " ", "+", " ", 
     SubscriptBox[
      OverscriptBox["P", "\[RightVector]"], 
      RowBox[{"A", " "}]]}]}], TraditionalForm]]],
 ".",
 Cell[BoxData[
  FormBox[
   RowBox[{" ", 
    RowBox[{
     SubscriptBox[
      OverscriptBox["\[Sigma]", "\[RightVector]"], 
      RowBox[{"A", " "}]], "  ", "+", " ", 
     SubscriptBox[
      OverscriptBox["P", "\[RightVector]"], 
      RowBox[{"B", " "}]]}]}], TraditionalForm]]],
 ".",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     OverscriptBox["\[Sigma]", "\[RightVector]"], "B"], " "}], 
   TraditionalForm]]],
 " + ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     OverscriptBox["\[Sigma]", "\[LongRightArrow]"], 
     RowBox[{"A", " "}]], " "}], TraditionalForm]]],
 ". ",
 Cell[BoxData[
  FormBox[
   OverscriptBox["T", "\[LongLeftRightArrow]"], TraditionalForm]]],
 " . ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox[
     OverscriptBox["\[Sigma]", "\[LongLeftArrow]"], 
     RowBox[{"A", " "}]], " "}], TraditionalForm]]],
 "]",
 StyleBox[" as discussed in the text.",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Sometimes we need a ",
  FontFamily->"Helvetica"],
 StyleBox["random one qubit density matrix",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" or a ",
  FontFamily->"Helvetica"],
 StyleBox["random 2 qubit density matrix",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[". Now the states are not pure states and thus the Purity is lower \
than one. The procedure used to build the random 2 qubit state can be easily \
generalized to the nqubit case.",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   RowBox[{
    SubscriptBox["\[Rho]", "one"], "=", "RandomQubit1"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Tr", "[", 
    SubscriptBox["\[Rho]", "one"], "]"}], "\[IndentingNewLine]", 
   RowBox[{"Chop", "[", 
    RowBox[{"Purity", "[", 
     SubscriptBox["\[Rho]", "one"], "]"}], "]"}]}]}]], "Input",
 CellTags->"b:5.1.4"],

Cell[BoxData[{
 RowBox[{
  SubscriptBox["\[Rho]", "two"], "=", "RandomQubit2"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  SubscriptBox["\[Rho]", "two"], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Chop", "[", 
  RowBox[{"Purity", "[", 
   SubscriptBox["\[Rho]", "two"], "]"}], "]"}]}], "Input",
 CellTags->"b:5.1.4"]
}, Open  ]],

Cell[TextData[StyleBox["Now the subsystems are also not pure states, for \
instance, the subsystem corresponding to qubit number 2 of the two qubits \
density matrix is obtained by performing the partial trace of qubit 1,",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.4"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", 
   RowBox[{"2", ",", "two"}]], "=", 
  RowBox[{"Chop", "[", 
   RowBox[{"PTr", "[", 
    RowBox[{
     RowBox[{"{", "1", "}"}], ",", 
     SubscriptBox["\[Rho]", "two"]}], "]"}], "]"}]}]], "Input",
 CellTags->"b:5.1.4"],

Cell[TextData[StyleBox["Analogous functions for one qubit Ket and Bra exist:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.4"],

Cell[BoxData[{"RandomKet1", "\[IndentingNewLine]", "RandomBra1"}], "Input",
 CellTags->"b:5.1.4"],

Cell[TextData[{
 StyleBox["Mathematica",
  FontFamily->"Helvetica",
  FontSlant->"Italic"],
 StyleBox[" contains convenient functions for dealing with matrices such as ",
  FontFamily->"Helvetica"],
 StyleBox["MatrixExp",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" and ",
  FontFamily->"Helvetica"],
 StyleBox["MatrixPower",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[". They allow one to easily construct ",
  FontFamily->"Helvetica"],
 StyleBox["Rotations ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox["and other operations:  \nThe equality ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SuperscriptBox["e", 
    RowBox[{"i", " ", "\[Alpha]", "  ", 
     SubscriptBox["\[Sigma]", "i"]}]], TraditionalForm]]],
 "= Cos \[Alpha]  ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Sigma]", "0"], TraditionalForm]]],
 " + i Sin \[Alpha] ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["\[Sigma]", "i"], TraditionalForm]]],
 "  ",
 StyleBox["can be demonstrated by comparing",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.4"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"ComplexExpand", "[", 
   RowBox[{"MatrixExp", "[", 
    RowBox[{"i", " ", "\[Alpha]", " ", 
     SubscriptBox["\[Sigma]", "1"]}], "]"}], "]"}]}]], "Input",
 CellTags->"b:5.1.4"],

Cell["to:", "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.4"],

Cell[BoxData[
 RowBox[{"TrigExpand", "[", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"Cos", "[", "\[Alpha]", "]"}], " ", 
     SubscriptBox["\[Sigma]", "0"]}], "+", " ", 
    RowBox[{"i", " ", 
     RowBox[{"Sin", "[", "\[Alpha]", "]"}], " ", 
     SubscriptBox["\[Sigma]", "1"]}]}], ")"}], "]"}]], "Input",
 CellTags->"b:5.1.4"],

Cell[BoxData[
 RowBox[{"MatrixExp", "[", 
  RowBox[{
   RowBox[{"-", "\[ImaginaryI]"}], "*", "\[Theta]", "*", 
   RowBox[{
    SubscriptBox["\[Sigma]", "3"], "/", "2"}]}], "]"}]], "Input",
 CellTags->"b:5.1.4"],

Cell[BoxData[
 RowBox[{"MatrixPower", "[", 
  RowBox[{
   SubscriptBox["\[Sigma]", "3"], ",", "3"}], "]"}]], "Input",
 CellTags->"b:5.1.4"],

Cell[TextData[{
 StyleBox["It allows us to check the formula ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"\[Sigma]", ".", "P"}], ")"}], "2"],
     TraditionalForm], "=", 
    SuperscriptBox["P", "2"]}], TraditionalForm]]]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.4"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"MatrixPower", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "*", 
      SubscriptBox["\[Sigma]", "1"]}], "+", 
     RowBox[{"b", "*", 
      SubscriptBox["\[Sigma]", "2"]}], "+", 
     RowBox[{"c", "*", 
      SubscriptBox["\[Sigma]", "3"]}]}], ",", "2"}], "]"}], "]"}]], "Input",
 CellTags->"b:5.1.4"],

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"MatrixPower", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"a", "*", 
      SubscriptBox["\[Sigma]", "1"]}], "+", 
     RowBox[{"b", "*", 
      SubscriptBox["\[Sigma]", "2"]}], "+", 
     RowBox[{"c", "*", 
      SubscriptBox["\[Sigma]", "3"]}]}], ",", "2"}], "]"}], "]"}]], "Input",
 CellTags->"b:5.1.4"],

Cell[TextData[StyleBox["The rotation of a qubit state is given later",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.1.4"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Quantum Gates", "Section",
 FontFamily->"Times",
 CellTags->{"Quantum Gates", "c:9"}],

Cell[TextData[StyleBox["In the density matrix language any operator [O] \
acting on the density matrix of the system \[Rho] acts producing:",
 FontFamily->"Helvetica"]], "Text",
 TextAlignment->Left,
 FontFamily->"Courier New"],

Cell[TextData[{
 StyleBox["\[Rho]' = ",
  FontFamily->"Helvetica",
  FontSize->14,
  FontWeight->"Bold"],
 Cell[BoxData[
  FormBox[
   RowBox[{"O", ".", "\[Rho]", ".", 
    SuperscriptBox["O", "\[Dagger]"]}], TraditionalForm]],
  FontWeight->"Bold"]
}], "Text",
 TextAlignment->-0.5,
 FontFamily->"Courier New"],

Cell[CellGroupData[{

Cell[TextData[StyleBox["a) Single qubit operations: Hadmards and rotations",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:10", "b:5.2.0"}],

Cell[TextData[{
 StyleBox["The ",
  FontFamily->"Helvetica"],
 StyleBox["Hadamard operator",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" for one qubit is defined as \nHad |0\[RightAngleBracket] = (|0\
\[RightAngleBracket] + |1\[RightAngleBracket])/ ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SqrtBox["2"], TraditionalForm]]],
 "  and Had |1\[RightAngleBracket] = ",
 StyleBox[" (|0\[RightAngleBracket] - |1\[RightAngleBracket])/ ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SqrtBox["2"], TraditionalForm]]],
 StyleBox[", \nthis is equivalent to Had = (",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["\[Sigma]",
     FontFamily->"Helvetica"], "1"], TraditionalForm]]],
 StyleBox[" + ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox[
    StyleBox["\[Sigma]",
     FontFamily->"Helvetica"], "3"], TraditionalForm]]],
 StyleBox["\[RightAngleBracket]/ ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SqrtBox["2"], TraditionalForm]]],
 StyleBox["\nTo Hadamard qubit one in a one qubit system use:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HA", " ", "=", " ", 
  RowBox[{"had", "[", 
   RowBox[{"1", ",", "1"}], "]"}]}]], "Input",
 CellTags->"b:5.2.0"],

Cell[TextData[StyleBox["or the script form:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[BoxData["\[ScriptCapitalH]"], "Input",
 CellTags->"b:5.2.0"],

Cell[TextData[StyleBox["If we have 3 qubits and want to Hadamard the second \
one,",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HAD32", "=", 
  RowBox[{"had", "[", 
   RowBox[{"3", ",", "2"}], "]"}]}]], "Input",
 CellTags->"b:5.2.0"],

Cell[TextData[StyleBox["which  is equivalent to",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
   "\[DoubleStruckCapitalI]", " ", "\[CircleTimes]", " ", 
    "\[ScriptCapitalH]"}], ")"}], "\[CircleTimes]", 
  "\[DoubleStruckCapitalI]"}]], "Input",
 CellTags->"b:5.2.0"]
}, Open  ]]
}, Open  ]],

Cell[TextData[StyleBox["If we want to apply Hadamards as above to an initial \
system of |000\[RightAngleBracket],  we construct the initial density matrix \
and transform to the new desnity matrix, also we check the subsystems 2 and 1 \
to verify that it is only qubit 2 that has been subjected to a Hadamard:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]000", "=", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[ScriptCapitalP]", "0"], "\[CircleTimes]", 
        SubscriptBox["\[ScriptCapitalP]", "0"]}], ")"}], "\[CircleTimes]", 
      SubscriptBox["\[ScriptCapitalP]", "0"]}], ")"}]}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]FINAL", "=", 
   RowBox[{
    RowBox[{"HAD32", " ", ".", " ", "\[Rho]000"}], " ", ".", " ", 
    RowBox[{"Adj", "[", "HAD32", "]"}]}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", "\[Rho]FINAL"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"PTr", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", "\[Rho]FINAL"}], "]"}]}], "Input",
 CellTags->"b:5.2.0"],

Cell[TextData[{
 StyleBox["Sometimes we need a ",
  FontFamily->"Helvetica"],
 StyleBox["Hadamard on every one of the qubits;",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" in that case you may use the command ",
  FontFamily->"Helvetica"],
 StyleBox["HALL",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[":",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HALL", "[", "3", "]"}], ".", "\[Rho]000", " ", ".", 
  RowBox[{"Adj", "[", 
   RowBox[{"HALL", "[", "3", "]"}], "]"}]}]], "Input",
 CellTags->{"i:2", "b:5.2.0"}],

Cell[TextData[StyleBox["The action of a Hadamard on state vectors is  also \
simple to evaluatel, ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"had", "[", 
   RowBox[{"1", ",", "1"}], "]"}], ".", 
  RowBox[{"Ket", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"had", "[", 
   RowBox[{"1", ",", "1"}], "]"}], ".", 
  RowBox[{"KetX", "[", "0", "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"had", "[", 
   RowBox[{"1", ",", "1"}], "]"}], ".", 
  RowBox[{"Ket", "[", "1", "]"}]}]}], "Input",
 CellTags->"b:5.2.0"],

Cell[TextData[StyleBox["A rotation around the y axis of an angle \[Theta] \
applied to a state |0\[RightAngleBracket] can be generated by the user as:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[BoxData[{
 RowBox[{"Roty", " ", "=", 
  RowBox[{"MatrixExp", "[", 
   RowBox[{
    RowBox[{"-", " ", "\[ImaginaryI]"}], "*", " ", 
    RowBox[{"s", "[", "2", "]"}], "*", 
    RowBox[{"\[Theta]", "/", "2"}]}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{"TrigReduce", "[", 
  RowBox[{"ComplexExpand", "[", 
   RowBox[{"Roty", "  ", ".", " ", 
    SubscriptBox["\[ScriptCapitalP]", "0"], ".", " ", 
    RowBox[{"Adj", "[", "Roty", " ", "]"}]}], "]"}], "]"}]}], "Input",
 CellTags->"b:5.2.0"],

Cell[TextData[{
 StyleBox["and we see that Roty on state | 0 \[RightAngleBracket] gives us \
Cos ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FractionBox["\[Theta]", "2"]]],
 StyleBox["  | 0\[RightAngleBracket] + Sin ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FractionBox["\[Theta]", "2"]]],
 StyleBox["  | 1\[RightAngleBracket];   for ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  RowBox[{"\[Theta]", " ", "=", " ", 
   RowBox[{"Pi", "/", "2"}]}]]],
 StyleBox["  gives ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 StyleBox[") ( | 0\[VeryThinSpace]\[RightAngleBracket] + | 1 \
\[RightAngleBracket])= |+\[RightAngleBracket].",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[BoxData[
 RowBox[{"Roty", ".", " ", 
  RowBox[{"Ket", "[", "0", "]"}]}]], "Input",
 CellTags->"b:5.2.0"],

Cell[TextData[{
 StyleBox["or the user can use the ",
  FontFamily->"Helvetica"],
 "QDENSITY",
 StyleBox[" command RotY[ ",
  FontFamily->"Helvetica"],
 "\[Theta]",
 StyleBox[" ]",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.0"],

Cell[BoxData[{
 RowBox[{"RotY", "[", "\[Theta]", "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RotY", "[", 
   RowBox[{"Pi", "/", "2"}], "]"}], ".", " ", 
  RowBox[{"Ket", "[", "0", "]"}]}]}], "Input",
 CellTags->"b:5.2.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["b) Two Qubit operations: CNOT gate",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"i:1", "c:11", "b:5.2.1"}],

Cell[TextData[{
 StyleBox["Two and in general n-qubit gates can be constructed. Among them \
the CNOT gate plays a very important role. A ",
  FontFamily->"Helvetica"],
 StyleBox["CNOT gate ( |a\[RightAngleBracket]|b\[RightAngleBracket]  -> |a\
\[RightAngleBracket]|(a ",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 Cell[BoxData[
  FormBox[
   RowBox[{"\[CirclePlus]", " "}], TraditionalForm]]],
 StyleBox["b) mod 2\[RightAngleBracket]) operating with qubit 1 as control \
and qubit 2 as target in a circuit with only two qubits",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" can be constructed as: ",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.1"],

Cell[BoxData[
 RowBox[{"CNOT", "[", 
  RowBox[{"2", ",", "1", ",", "2"}], "]"}]], "Input",
 CellTags->"b:5.2.1"],

Cell[TextData[{
 StyleBox["If we apply the ",
  FontFamily->"Helvetica"],
 StyleBox["CNOT",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" to an initial density matrix  |10\[RightAngleBracket]\
\[LeftAngleBracket]10|, we write, ",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CNOT", "[", 
   RowBox[{"2", ",", "1", ",", "2"}], "]"}], " ", ".", " ", 
  RowBox[{"(", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "1"], "\[CircleTimes]", 
    SubscriptBox["\[ScriptCapitalP]", "0"]}], ")"}], ".", 
  RowBox[{"Adj", "[", 
   RowBox[{"CNOT", "[", 
    RowBox[{"2", ",", "1", ",", "2"}], "]"}], "]"}]}]], "Input",
 CellTags->"b:5.2.1"],

Cell[TextData[StyleBox["which trivially  is seen to be equal to the density \
matrix for |11\[RightAngleBracket]\[LeftAngleBracket]11|",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.1"],

Cell[BoxData[
 RowBox[{"(", 
  RowBox[{
   SubscriptBox["\[ScriptCapitalP]", "1"], "\[CircleTimes]", 
   SubscriptBox["\[ScriptCapitalP]", "1"]}], ")"}]], "Input",
 CellTags->"b:5.2.1"],

Cell[TextData[{
 StyleBox["A ",
  FontFamily->"Helvetica"],
 StyleBox["more general case",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" would be to have a CNOT gate with control in qubit 3 and target \
in qubit 5 in a circuit with 6 qubits:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"CNOT", "[", 
   RowBox[{"6", ",", "3", ",", "5"}], "]"}], ";"}]], "Input",
 CellTags->"b:5.2.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["c) Two Qubit operations (CPHASE)",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"i:1", "c:12", "b:5.2.2"}],

Cell[TextData[StyleBox["The Cphase operation, used mainly in the cluster \
model approach, is defined by:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox["CPHASE | a b \[RightAngleBracket] = (-1)^(ab)  | a b \
\[RightAngleBracket]",
 FontFamily->"Helvetica",
 FontWeight->"Bold"]], "Text",
 TextAlignment->-0.5,
 FontFamily->"Courier New",
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox[" Its syntax is is similar to a CNOT gate, but in this \
case the order of the control and target qubits is not relevant. \nTherefore, \
CPHASE[L,q1,q2], performs a CPHASE gate on qubits q1 and q2 on a system of L \
qubits.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.2"],

Cell[BoxData[{
 RowBox[{"CPHASE", "[", 
  RowBox[{"2", ",", "1", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"CPHASE", "[", 
  RowBox[{"2", ",", "2", ",", "1"}], "]"}]}], "Input",
 CellTags->"b:5.2.2"],

Cell[TextData[{
 StyleBox["In a multiquibit environment: of say three qubits, a ",
  FontFamily->"Helvetica"],
 StyleBox["CPHASE",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" between qubits 1 and 2 is:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.2"],

Cell[BoxData[
 RowBox[{"CPHASE", "[", 
  RowBox[{"3", ",", "2", ",", "1"}], "]"}]], "Input",
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox["A different version of the same gate  is defined by \
CPHASEV[ i,  j,  a ]  and is used to get the CPHASE action on qubits i and j \
of a  state vector a.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox["For instance, if we apply CPHASE to the two qubit \
vector:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox["CPHASE[ 2, 1, 2]   [  a | 0 0 \[RightAngleBracket]+  \
b | 0 1 \[RightAngleBracket] +  c | 1 0 \[RightAngleBracket] + d | 1 1 \
\[RightAngleBracket] ]  =   a | 0 0\[RightAngleBracket]+ b | 0 1\
\[RightAngleBracket]+ c | 1 0\[RightAngleBracket]  -  d | 1 1\
\[RightAngleBracket]",
 FontFamily->"Helvetica",
 FontWeight->"Bold"]], "Text",
 TextAlignment->-0.5,
 FontFamily->"Courier New",
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox["Which corresponds to the followng command:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.2"],

Cell[BoxData[
 RowBox[{"CPHASEV", "[", 
  RowBox[{"1", ",", "2", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "}"}]}], "]"}]], "Input",
 CellTags->"b:5.2.2"],

Cell[TextData[StyleBox["Thus CPHASEV[  i  , j , a]  gives the result of  a \
CPHASE acting on qubits i and j for a state vector with expansion \
coefficients a:{a,b,c.....}.  The length of the array gives the total number \
of qubits.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.2"],

Cell[BoxData[
 RowBox[{"CPHASEV", "[", 
  RowBox[{"1", ",", "3", ",", 
   RowBox[{"{", 
    RowBox[{
    "a", ",", "b", ",", "c", ",", "d", ",", "e", ",", "f", ",", "g", ",", 
     "h"}], "}"}]}], "]"}]], "Input",
 CellTags->"b:5.2.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["d) Two Qubit operations, TwoOp",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"i:1", "c:13", "b:5.2.3"}],

Cell[TextData[StyleBox["General Two Qubit operations are build using TwoOp. \
Its syntax is is very simple and allows one to build any two qubit operation \
embedded in an L qubit system. ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.3"],

Cell[TextData[{
 StyleBox["The TwoOp function should be called with the following arguments: \
\nL: total number of qubits, ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "1"], TraditionalForm]]],
 "and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]]],
 ", ",
 StyleBox["qubits involved in the operation, ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["op", "1"], "and", " ", 
    SubscriptBox["op", "2"]}], TraditionalForm]]],
 " ",
 StyleBox["are the Pauli \noperators ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["\[Sigma]", 
      SubscriptBox["op", "1"]], ",", 
     SubscriptBox["\[Sigma]", 
      SubscriptBox["op", "2"]]}], ")"}], TraditionalForm]]],
 " ",
 StyleBox["performed on",
  FontFamily->"Helvetica"],
 " ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "1"], TraditionalForm]]],
 "and ",
 Cell[BoxData[
  FormBox[
   SubscriptBox["q", "2"], TraditionalForm]]],
 ".\n",
 StyleBox["Thus for a three qubit system with  ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  RowBox[{
   SubscriptBox["\[Sigma]", "0"], "  ", "acting", " ", "on", " ", "qubit", 
   " ", "1", "  ", "and"}]],
  FontFamily->"Helvetica"],
 StyleBox[" ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  RowBox[{
   RowBox[{
    SubscriptBox["\[Sigma]", "1"], "  ", "acting", " ", "on", " ", "qubit", 
    " ", "2"}], ",", " ", 
   RowBox[{"the", " ", "operator", " ", "is"}]}]],
  FontFamily->"Helvetica"],
 StyleBox[" ",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.3"],

Cell[BoxData[
 RowBox[{"TwoOp", "[", 
  RowBox[{"3", ",", "1", ",", "2", ",", "0", ",", "1"}], "]"}]], "Input",
 CellTags->"b:5.2.3"],

Cell[TextData[{
 StyleBox["For example, the CNOT and CPHASE gates between any two qubits in a \
total of L qubits have been coded using this function.\nA ThreeOp[ L,  i,  j, \
k, ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["op", "1"], TraditionalForm]],
  FontFamily->"Helvetica"],
 StyleBox[" ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["op", "2"], TraditionalForm]],
  FontFamily->"Helvetica"],
 StyleBox[" ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SubscriptBox["op", "3"], TraditionalForm]],
  FontFamily->"Helvetica"],
 StyleBox["] is also provided by ",
  FontFamily->"Helvetica"],
 "QDENSITY",
 StyleBox[", which also serves as a building block for higher order \
operators.",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.2.3"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Measurements", "Section",
 FontFamily->"Times",
 CellTags->{"Measurement", "c:14"}],

Cell[CellGroupData[{

Cell[TextData[StyleBox["a) Measuring  in the computational bases with density \
matrix",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"Measurements", "c:15", "b:5.3.0"}],

Cell[TextData[StyleBox["A projective measurement on our system corresponds to \
a projection of the density matrix of the full system into the unmeasured \
subsytem.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.0"],

Cell[TextData[{
 StyleBox["Let us assume we have a four qubit system initially in the | 0 0 0 \
0 \[RightAngleBracket] state, we build  its density matrix ",
  FontFamily->"Helvetica"],
 "\[Rho]4",
 StyleBox["  after a chain of Hadamard and CNOT gates act as,",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ope", "=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "2"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "3", ",", "4"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "1"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "1", ",", "4"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "3"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]4", "=", 
  RowBox[{"Ope", ".", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[ScriptCapitalP]", "0"], "  ", "\[CircleTimes]", "  ", 
         SubscriptBox["\[ScriptCapitalP]", "0"]}], ")"}], " ", 
       "\[CircleTimes]", 
       SubscriptBox["\[ScriptCapitalP]", "0"]}], ")"}], " ", "\[CircleTimes]",
      "  ", 
     SubscriptBox["\[ScriptCapitalP]", "0"]}], ")"}], ".", 
   RowBox[{"Adj", "[", "Ope", "]"}]}]}]}], "Input",
 CellTags->"b:5.3.0"],

Cell[TextData[StyleBox["We can then measure for instance qubits 1 and 3 \
simultaneously, the projection operator would be:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.0"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["P", 
   RowBox[{"a_", ",", "b_"}]], "  ", ":=", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", " ", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[ScriptCapitalP]", "a"], "  ", "\[CircleTimes]", "  ", 
        "\[DoubleStruckCapitalI]"}], ")"}], "\[CircleTimes]", 
      SubscriptBox["\[ScriptCapitalP]", "b"]}], ")"}], "\[CircleTimes]", " ", 
    "\[DoubleStruckCapitalI]"}], ")"}]}]], "Input",
 CellTags->"b:5.3.0"],

Cell[TextData[StyleBox["And therefore the state of the remaining subsystem, \
which depends on the values measured, after the measurement reads, ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.0"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]24", "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"Chop", "[", " ", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}], "  ", ",", 
      RowBox[{
       RowBox[{"2", "^", "2"}], "*", 
       RowBox[{
        SubscriptBox["P", 
         RowBox[{"a", ",", "b"}]], ".", "\[Rho]4", ".", 
        SubscriptBox["P", 
         RowBox[{"a", ",", "b"}]]}]}]}], " ", "]"}], "]"}]}], ";"}]], "Input",
 CellTags->"b:5.3.0"],

Cell[TextData[StyleBox["If the result of the measurement was (01) then we \
would have the following density matrix for the remaining subsystem:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.0"],

Cell[BoxData[{
 RowBox[{"\[Rho]24", "[", 
  RowBox[{"0", ",", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  RowBox[{"\[Rho]24", "[", 
   RowBox[{"0", ",", "1"}], "]"}], "]"}]}], "Input",
 CellTags->"b:5.3.0"],

Cell[TextData[StyleBox["The computation could be left depending on the values \
of the measurement:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.0"],

Cell[BoxData[{
 RowBox[{"\[Rho]24", "[", 
  RowBox[{"a", ",", "b"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Tr", "[", 
  RowBox[{"\[Rho]24", "[", 
   RowBox[{"a", ",", "b"}], "]"}], "]"}]}], "Input",
 CellTags->"b:5.3.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["b) Measuring  in the computational bases using \
MeasureKet",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}],

Cell[TextData[StyleBox["Consider a similar example to the previous one, using \
kets:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ope", "=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "2"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "3", ",", "4"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "1"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"4", ",", "1", ",", "4"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"4", ",", "3"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"ket1234", "=", 
  RowBox[{"Ope", ".", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"Ket", "[", "0", "]"}], "  ", "\[CircleTimes]", "  ", 
         RowBox[{"Ket", "[", "0", "]"}]}], ")"}], " ", "\[CircleTimes]", 
       RowBox[{"Ket", "[", "0", "]"}]}], ")"}], " ", "\[CircleTimes]", "  ", 
     RowBox[{"Ket", "[", "0", "]"}]}], ")"}]}]}]}], "Input",
 CellTags->"b:5.3.1"],

Cell[TextData[StyleBox["We can then measure for instance qubits 1 and 3 \
simultaneously, using MeasureKet.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.1"],

Cell[TextData[StyleBox["The state of the remaining twoqubit subsystem, which \
depends on the values measured, after the measurement reads, ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.1"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ket24", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{"MeasureKet", "[", 
   RowBox[{"ket1234", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"a", ",", "b"}], "}"}]}], "]"}]}]], "Input",
 CellTags->"b:5.3.1"],

Cell[TextData[StyleBox["If the result of the measurement was (01) then we \
would have the following ket for the remaining  qubit 2 and 4 subsystem:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.1"],

Cell[BoxData[
 RowBox[{"ket24", "[", 
  RowBox[{"0", ",", "1"}], "]"}]], "Input",
 CellTags->"b:5.3.1"],

Cell[TextData[StyleBox["Construct the back to back density matrix for that \
state:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.1"],

Cell[BoxData[
 RowBox[{"\[Rho]24k", "=", 
  RowBox[{
   RowBox[{"ket24", "[", 
    RowBox[{"0", ",", "1"}], "]"}], "\[CircleTimes]", 
   RowBox[{"Adj", "[", 
    RowBox[{"ket24", "[", 
     RowBox[{"0", ",", "1"}], "]"}], "]"}]}]}]], "Input",
 CellTags->"b:5.3.1"],

Cell[BoxData[
 RowBox[{"Purity", "[", "\[Rho]24k", "]"}]], "Input",
 CellTags->"b:5.3.1"],

Cell[TextData[StyleBox["Which is identical to the density matrix obtained \
earlier",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["c) Example with measurements in the X and Y bases \
using the density matrix",
 FontWeight->"Bold"]], "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:17", "b:5.3.2"}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/Had5q.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure", "]"}]}], "Input",
 CellTags->"b:5.3.2"],

Cell[TextData[StyleBox["Let us  assume we have a five qubit system built as \
in the figure, which corresponds to:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Ope2", "=", 
   RowBox[{
    RowBox[{"CPHASE", "[", 
     RowBox[{"5", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"CPHASE", "[", 
     RowBox[{"5", ",", "2", ",", "3"}], "]"}], ".", 
    RowBox[{"CPHASE", "[", 
     RowBox[{"5", ",", "3", ",", "4"}], "]"}], ".", 
    RowBox[{"CPHASE", "[", 
     RowBox[{"5", ",", "4", ",", "5"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]1", "=", "RandomQubit1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]Initial", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"\[Rho]1", "\[CircleTimes]", 
           RowBox[{"PX", "[", "0", "]"}]}], ")"}], "\[CircleTimes]", "  ", 
         RowBox[{"PX", "[", "0", "]"}]}], ")"}], " ", "\[CircleTimes]", 
       RowBox[{"PX", "[", "0", "]"}]}], ")"}], "\[CircleTimes]", 
     RowBox[{"PX", "[", "0", "]"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]12345", "=", 
   RowBox[{"Chop", "[", " ", 
    RowBox[{"Ope2", ".", "\[Rho]Initial", ".", 
     RowBox[{"Adj", "[", "Ope2", "]"}]}], "]"}]}], ";"}]}], "Input",
 CellTags->"b:5.3.2"],

Cell[TextData[StyleBox["We now measure qubit 1 in the X basis, qubits 2, 3 \
and 4 in the Y basis and check what  \nwe have in qubit 5 ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.2"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["PP", 
   RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}]], "  ", ":=", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          RowBox[{"PX", "[", "a", "]"}], " ", "\[CircleTimes]", "  ", 
          RowBox[{"PY", "[", "b", "]"}]}], ")"}], "\[CircleTimes]", 
        RowBox[{"PY", "[", "c", "]"}]}], ")"}], "\[CircleTimes]", " ", 
      RowBox[{"PY", "[", "d", "]"}]}], ")"}], "\[CircleTimes]", 
    "\[DoubleStruckCapitalI]"}], ")"}]}]], "Input",
 CellTags->"b:5.3.2"],

Cell[TextData[{
 StyleBox["(this proyector could have been written using ",
  FontFamily->"Helvetica"],
 StyleBox["MultiQProj[{1,2,2,2,0},{a,b,c,d,0}] )",
  FontFamily->"Helvetica",
  FontWeight->"Bold"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.2"],

Cell[TextData[StyleBox["And therefore the state of the remaining subsystem, \
which depends on the values measured, after the measurement reads, ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]5", "[", 
    RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "]"}], ":=", 
   RowBox[{"Chop", "[", " ", 
    RowBox[{"PTr", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3", ",", "4"}], "}"}], "  ", ",", 
      RowBox[{
       RowBox[{"2", "^", "4"}], "*", 
       RowBox[{
        SubscriptBox["PP", 
         RowBox[{"a", ",", "b", ",", "c", ",", "d"}]], ".", "\[Rho]12345", 
        ".", 
        RowBox[{"Adj", "[", 
         SubscriptBox["PP", 
          RowBox[{"a", ",", "b", ",", "c", ",", "d"}]], " ", "]"}]}]}]}], 
     "]"}], "]"}]}], ";"}]], "Input",
 CellTags->"b:5.3.2"],

Cell[TextData[StyleBox["If the result of the measurement was 1 for qubit 2 in \
the Z bases and 0 for qubit 3 in the X bases then the \nstate of qubits 1 and \
4 would be given by the following:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.2"],

Cell[BoxData[
 RowBox[{"\[Rho]5", "[", 
  RowBox[{"0", ",", "1", ",", "1", ",", "1"}], "]"}]], "Input",
 CellTags->"b:5.3.2"],

Cell[TextData[StyleBox["Now we can relate this problem to the realization of \
a Hadamard in the Cluster Model, in fact, our \nexample corresponds exactly \
to Fig 2(d) of Raussendorf et al., Phys. Rev. A 022312 (2003). \nTherefore \
according to those authors the output should be, up to a prefactor depending \
on the\nprevious measurements, a Hadamard of the first qubit:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.2"],

Cell[TextData[StyleBox["The prefactor is the following:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.2"],

Cell[TextData[{
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["U", 
     RowBox[{"\[CapitalSigma]", ",", "H"}]], "="}], TraditionalForm]],
  FontSize->14],
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SuperscriptBox[
      SubscriptBox["\[Sigma]", "x"], 
      RowBox[{"a", "+", "c", "+", "d"}]],
     TraditionalForm], 
    SuperscriptBox[
     SubscriptBox["\[Sigma]", "z"], 
     RowBox[{"b", "+", "c"}]]}], TraditionalForm]],
  FontSize->14]
}], "Text",
 TextAlignment->-0.5,
 FontFamily->"Courier New",
 CellTags->"b:5.3.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Prefactor", "[", 
   RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"MatrixPower", "[", 
    RowBox[{
     SubscriptBox["\[Sigma]", "1"], ",", 
     RowBox[{"a", "+", "c", "+", "d"}]}], "]"}], ".", 
   RowBox[{"MatrixPower", "[", 
    RowBox[{
     SubscriptBox["\[Sigma]", "3"], ",", 
     RowBox[{"b", "+", "c"}]}], "]"}]}]}]], "Input",
 CellTags->"b:5.3.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Rho]5Final", "[", 
   RowBox[{"a_", ",", "b_", ",", "c_", ",", "d_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Prefactor", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ".", 
   RowBox[{"\[Rho]5", "[", 
    RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], ".", 
   RowBox[{"Adj", "[", 
    RowBox[{"Prefactor", "[", 
     RowBox[{"a", ",", "b", ",", "c", ",", "d"}], "]"}], "]"}]}]}]], "Input",
 CellTags->"b:5.3.2"],

Cell[BoxData[
 RowBox[{"Chop", "[", 
  RowBox[{"\[Rho]5Final", "[", 
   RowBox[{"1", ",", "1", ",", "0", ",", "1"}], "]"}], "]"}]], "Input",
 CellTags->"b:5.3.2"],

Cell[BoxData[
 RowBox[{"Chop", "[", 
  RowBox[{
   RowBox[{"had", "[", 
    RowBox[{"1", ",", "1"}], "]"}], ".", "\[Rho]1", ".", 
   RowBox[{"Adj", "[", 
    RowBox[{"had", "[", 
     RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "]"}]], "Input",
 CellTags->"b:5.3.2"],

Cell[TextData[StyleBox["The equivalence of the above two results confirms \
that the cluster diagram and the prefactor step does indeed represent a \
Hadamard.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.3.2"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Miscellaneous", "Section",
 FontFamily->"Times",
 CellTags->{"Measurement", "c:18"}],

Cell[CellGroupData[{

Cell["a) Von Neumann Entropy", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:19", "b:5.4.0"}],

Cell[TextData[StyleBox["The Von Neumann entropy is defined as:  S[\[Rho]] = - \
Tr [\[Rho] Log[2,\[Rho] ] ]",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.0"],

Cell[TextData[{
 StyleBox["Which can be rewritten as  S[\[Rho]] = -\[Sum] ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    FormBox[
     SubscriptBox["\[Rho]", "\[Lambda]"],
     TraditionalForm], 
    RowBox[{"Log", "[", 
     RowBox[{"2", ",", 
      SubscriptBox["\[Rho]", "\[Lambda]"]}], "]"}]}], TraditionalForm]]],
 StyleBox[" \n",
  FontFamily->"Helvetica"],
 StyleBox["where ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["\[Rho]", "\[Lambda]"], " "}], TraditionalForm]],
  FontFamily->"Helvetica"],
 StyleBox["are the eigenvalues of \[Rho], and we keep the convenction",
  FontFamily->"Helvetica"],
 " 0*Log[2,0]:=0"
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.0"],

Cell[TextData[{
 StyleBox["The Function Entropy[ ] is already defined in ",
  FontFamily->"Helvetica"],
 "QDENSITY",
 StyleBox[", let's check some examples, Ex 11.11 and 11.12 of Nielsen and \
Chuang:",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.0"],

Cell[BoxData[{
 RowBox[{"\[Rho]1", "=", 
  SubscriptBox["\[ScriptCapitalP]", 
   StyleBox["0",
    ScriptLevel->0]]}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]2", "=", 
  RowBox[{
   RowBox[{"1", "/", "2"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"s", "[", "0", "]"}], "+", 
     RowBox[{"s", "[", "1", "]"}]}], ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"\[Rho]3", "=", 
  RowBox[{
   RowBox[{"1", "/", "3"}], "*", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"s", "[", "0", "]"}], "+", 
     RowBox[{"s", "[", "1", "]"}], "+", 
     SubscriptBox["\[ScriptCapitalP]", 
      StyleBox["0",
       ScriptLevel->0]]}], ")"}]}]}]}], "Input",
 CellTags->"b:5.4.0"],

Cell[TextData[StyleBox["..and their entropies are:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.0"],

Cell[BoxData[{
 RowBox[{"Entropy", "[", "\[Rho]1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Entropy", "[", "\[Rho]2", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Entropy", "[", "\[Rho]3", "]"}], "\[IndentingNewLine]", 
 RowBox[{"N", "[", "%", "]"}]}], "Input",
 CellTags->"b:5.4.0"],

Cell[TextData[StyleBox[" Now lets check 11.12",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.0"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]Entropy", "[", "p_", "]"}], ":=", 
   RowBox[{
    RowBox[{"p", " ", 
     SubscriptBox["\[ScriptCapitalP]", "0"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "p"}], ")"}], " ", 
     RowBox[{"PX", "[", "0", "]"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"M", "[", "p_", "]"}], ":=", 
   RowBox[{"Eigenvalues", "[", 
    RowBox[{"\[Rho]Entropy", "[", "p", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MP", "[", "p_", "]"}], "=", 
   RowBox[{"Select", "[", 
    RowBox[{
     RowBox[{"M", "[", "p", "]"}], ",", "Positive"}], "]"}]}], ";"}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Entropy", "[", 
    RowBox[{"\[Rho]Entropy", "[", "p", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<p\>\"", ",", "\"\<Entropy\>\""}], "}"}]}]}], 
  "]"}]}], "Input",
 CellTags->"b:5.4.0"],

Cell[TextData[{
 StyleBox["Examples using GHZ and other Multi-qubit states are easily \
generated in ",
  FontFamily->"Helvetica"],
 "QDENSITY",
 StyleBox[".",
  FontFamily->"Helvetica"]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.0"]
}, Open  ]],

Cell[CellGroupData[{

Cell["b) Fidelity", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:20", "b:5.4.1"}],

Cell[TextData[{
 StyleBox["The fidelity of two states is defined:  Fidelity",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{"[", 
    RowBox[{
     SubscriptBox["\[Rho]", "1"], ",", 
     SubscriptBox["\[Rho]", "2"]}]}], TraditionalForm]]],
 StyleBox["] = Tr [ ",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   SqrtBox[
    RowBox[{
     SqrtBox[
      SubscriptBox["\[Rho]", "2"]], ".", 
     SubscriptBox["\[Rho]", "1"], ".", 
     SqrtBox[
      SubscriptBox["\[Rho]", "2"]]}]], TraditionalForm]]]
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.1"],

Cell[BoxData[{
 RowBox[{"State1", "=", "RandomQubit2"}], "\[IndentingNewLine]", 
 RowBox[{"State2", "=", "RandomQubit2"}]}], "Input",
 CellTags->"b:5.4.1"],

Cell[TextData[StyleBox["their fidelity is:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.1"],

Cell[BoxData[{
 RowBox[{"Fidelity", "[", 
  RowBox[{"State1", ",", "State2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Fidelity", "[", 
  RowBox[{"State2", ",", "State1"}], "]"}]}], "Input",
 CellTags->"b:5.4.1"],

Cell[TextData[StyleBox[" The fidelity is one if both states are the same:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.1"],

Cell[BoxData[
 RowBox[{"Fidelity", "[", 
  RowBox[{"State1", ",", "State1"}], "]"}]], "Input",
 CellTags->"b:5.4.1"],

Cell[TextData[StyleBox[" Let's see the behavior of the Fidelity for a couple \
of interesting examples:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]Fid", "[", "p_", "]"}], ":=", 
   RowBox[{
    RowBox[{"p", " ", 
     SubscriptBox["\[ScriptCapitalP]", "1"]}], "+", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "-", "p"}], ")"}], " ", 
     RowBox[{"PX", "[", "1", "]"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Fide", "[", "p_", "]"}], ":=", 
  RowBox[{"Fidelity", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], ",", 
    RowBox[{"\[Rho]Fid", "[", "p", "]"}]}], "]"}]}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Abs", "[", 
    RowBox[{"Fide", "[", "p", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", 
     RowBox[{"-", "5"}], ",", "7"}], "}"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<p\>\"", ",", "\"\<Fidelity\>\""}], "}"}]}]}], 
  "]"}]}], "Input",
 CellTags->"b:5.4.1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]Fid2", "[", "p_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     SuperscriptBox[
      RowBox[{"Sin", "[", "p", "]"}], "2"], " ", 
     SubscriptBox["\[ScriptCapitalP]", "1"]}], "+", 
    RowBox[{
     SuperscriptBox[
      RowBox[{"Cos", "[", "p", "]"}], "2"], " ", 
     RowBox[{"PX", "[", "0", "]"}]}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Fide", "[", "p_", "]"}], ":=", 
  RowBox[{"Fidelity", "[", 
   RowBox[{
    SubscriptBox["\[ScriptCapitalP]", "0"], ",", 
    RowBox[{"\[Rho]Fid2", "[", "p", "]"}]}], "]"}]}], "\n", 
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Abs", "[", 
    RowBox[{"Fide", "[", "p", "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"p", ",", "0", ",", 
     RowBox[{"4", " ", "\[Pi]"}]}], "}"}], ",", 
   RowBox[{"AxesLabel", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<p\>\"", ",", "\"\<Fidelity\>\""}], "}"}]}]}], 
  "]"}]}], "Input",
 CellTags->"b:5.4.1"]
}, Open  ]],

Cell[CellGroupData[{

Cell["c) GHZ study", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:4", "b:5.4.2"}],

Cell["\<\
Start with a pure three qubit state in the computational basis |abc\
\[RightAngleBracket]\[LeftAngleBracket]abc| :\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{
  SubscriptBox["\[Rho]", 
   RowBox[{"a_", ",", "b_", ",", "c_"}]], ":=", " ", 
  RowBox[{
   StyleBox[
    SubscriptBox["\[ScriptCapitalP]", "a"],
    ScriptLevel->0], "\[CircleTimes]", " ", 
   RowBox[{"(", 
    StyleBox[
     RowBox[{
      SubscriptBox["\[ScriptCapitalP]", "b"], "\[CircleTimes]", 
      SubscriptBox["\[ScriptCapitalP]", "c"]}],
     ScriptLevel->0], 
    StyleBox[")",
     ScriptLevel->0]}]}]}]], "Input",
 CellTags->"b:5.4.2"],

Cell[" Generate GHZ state operator as seen in the figure:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"figure2", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"\"\<QDENSITY/drawings/gGHZ.png\>\"", ",", "\"\<PNG\>\""}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Show", "[", "figure2", "]"}]}], "Input",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{"Clear", "[", "GHZop", "]"}]], "Input",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"GHZop", "[", 
   RowBox[{"qi_", ",", "qj_", ",", "qk_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "qi", ",", "qk"}], "]"}], ".", 
    RowBox[{"CNOT", "[", 
     RowBox[{"3", ",", "qi", ",", "qj"}], "]"}]}], ".", 
   RowBox[{"had", "[", 
    RowBox[{"3", ",", "qi"}], "]"}]}], " "}]], "Input",
 FontFamily->"Courier New",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{"  ", 
  RowBox[{
   RowBox[{
   "GHZ\[Rho]", "   ", "is", " ", "the", " ", "density", " ", "matrix", "  ", 
    "of", " ", "any", " ", "of", " ", "the", " ", "GHZ", " ", "states"}], ",",
    " ", 
   RowBox[{"depending", " ", "on", " ", "the", " ", "initial", " ", 
    RowBox[{"state", ":", " "}]}]}]}]], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 StyleBox[
  RowBox[{" ", 
   RowBox[{
    RowBox[{
     SubscriptBox[
      StyleBox[
       RowBox[{"G", 
        StyleBox["HZ",
         FontSize->12], "\[Rho]"}]], 
      RowBox[{"a_", ",", "b_", ",", "c_"}]], "  ", ":=", 
     RowBox[{
      RowBox[{"GHZop", "[", 
       RowBox[{"1", ",", "2", ",", "3"}], "]"}], ".", 
      SubscriptBox["\[Rho]", 
       RowBox[{"a", ",", "b", ",", "c"}]], ".", 
      RowBox[{"Adj", "[", 
       RowBox[{"GHZop", "[", 
        RowBox[{"1", ",", "2", ",", "3"}], "]"}], "]"}]}]}], ";"}]}],
  FontSize->12]], "Input",
 FontFamily->"Courier New",
 FontSize->12,
 CellTags->"b:5.4.2"],

Cell[" Checks on some of the GHZ states: ", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"0", ",", "0", ",", "0"}]]], "Input",
 CellTags->"b:5.4.2"],

Cell[BoxData[{
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"0", ",", "0", ",", "1"}]], "\[IndentingNewLine]", 
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"1", ",", "0", ",", "1"}]]}], "Input",
 CellTags->"b:5.4.2"],

Cell[BoxData[{
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"0", ",", "1", ",", "0"}]], "\[IndentingNewLine]", 
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"1", ",", "1", ",", "0"}]]}], "Input",
 CellTags->"b:5.4.2"],

Cell[BoxData[{
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"0", ",", "1", ",", "1"}]], "\[IndentingNewLine]", 
 SubscriptBox[
  StyleBox[
   RowBox[{"G", 
    StyleBox["HZ",
     FontSize->12], "\[Rho]"}]], 
  RowBox[{"1", ",", "1", ",", "1"}]]}], "Input",
 CellTags->"b:5.4.2"],

Cell["\<\
Now we will focus on one of the states, the usual GHZ, and study its 
properties:
 Vector and tensor polarizations of GHZ state 
 Vector polarizations are zero for GHZ states 
 Rank 2 Tensor polarizations for GHZ state 
 Rank 3 Tensor polarizations for GHZ state \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{
  StyleBox[
   SubscriptBox["\[Rho]", "GHZ"],
   FontSize->12], "=", 
  SubscriptBox[
   StyleBox[
    RowBox[{"G", 
     StyleBox["HZ",
      FontSize->12], "\[Rho]"}]], 
   RowBox[{"0", ",", "0", ",", "0"}]]}]], "Input",
 CellTags->"b:5.4.2"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i_", ",", "j_", ",", "k_"}], "]"}], ":=", 
   RowBox[{"Tr", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         SubscriptBox["\[Sigma]", "i"], "\[CircleTimes]", 
         SubscriptBox["\[Sigma]", "j"]}], ")"}], "\[CircleTimes]", 
       SubscriptBox["\[Sigma]", "k"]}], ")"}], ".", 
     StyleBox[
      SubscriptBox["\[Rho]", "GHZ"],
      FontSize->12]}], 
    StyleBox[" ",
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{
     StyleBox["P",
      FontSize->12], "GHZ", 
     StyleBox["A",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"1", ",", "0", ",", "0"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"2", ",", "0", ",", "0"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"3", ",", "0", ",", "0"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{
     StyleBox["P",
      FontSize->12], "GHZ", 
     StyleBox["B",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"0", ",", "1", ",", "0"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "2", ",", "0"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "3", ",", "0"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{
     StyleBox["P",
      FontSize->12], "GHZ", 
     StyleBox["C",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"0", ",", "0", ",", "1"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "0", ",", "2"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "0", ",", "3"}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"TGHZ", 
     StyleBox["AB",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"i", ",", "j", ",", "0"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"TGHZ", 
     StyleBox["AC",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"i", ",", "0", ",", "j"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TGHZBC", 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"i", ",", "j", ",", "0"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{"TGHZ", 
     StyleBox["ABC",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox["Table",
      FontSize->12], 
     StyleBox["[",
      FontSize->12], 
     RowBox[{
      StyleBox[
       RowBox[{"T", "[", 
        RowBox[{"i", ",", "j", ",", "k"}], "]"}],
       FontSize->12], 
      StyleBox[",",
       FontSize->12], 
      RowBox[{"{", 
       RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "1", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"k", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", "PGHZA", "\[IndentingNewLine]", "PGHZB", "\
\[IndentingNewLine]", "PGHZC", "\[IndentingNewLine]", 
 RowBox[{"Flatten", "[", 
  RowBox[{"TGHZAB", ",", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Flatten", "[", 
  RowBox[{"TGHZAC", ",", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Flatten", "[", 
  RowBox[{"TGHZBC", ",", "1"}], 
  "]"}], "\[IndentingNewLine]", "TGHZABC"}], "Input",
 FontFamily->"Courier New",
 CellTags->"b:5.4.2"],

Cell[BoxData[{
 RowBox[{"T", "[", 
  RowBox[{"1", ",", "1", ",", "1"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"T", "[", 
  RowBox[{"1", ",", "2", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"T", "[", 
  RowBox[{"2", ",", "1", ",", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"T", "[", 
  RowBox[{"2", ",", "2", ",", "1"}], "]"}]}], "Input",
 CellTags->"b:5.4.2"],

Cell["We can reconstruct the Density Matrix ", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"1", "/", "8"}], ")"}], "  ", 
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"i", "=", "0"}], "3"], "   ", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"j", "=", "0"}], "3"], "  ", 
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"k", "=", "0"}], "3"], "  ", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"i", ",", "j", ",", "k"}], "]"}], "*", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["\[Sigma]", "i"], "\[CircleTimes]", 
          SubscriptBox["\[Sigma]", "j"]}], ")"}], "\[CircleTimes]", 
        SubscriptBox["\[Sigma]", "k"]}], ")"}]}]}]}]}]}]], "Input",
 CellTags->"b:5.4.2"],

Cell["or, identically making use of the general SP function: ", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{"1", "/", "8"}], ")"}], "   ", 
  RowBox[{"(", "  ", 
   RowBox[{
    RowBox[{"SP", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0"}], "}"}]}], "]"}], "  ", "+", " ", 
    RowBox[{"SP", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "3", ",", "0"}], "}"}]}], "]"}], "+", " ", 
    RowBox[{"SP", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "0", ",", "3"}], "}"}]}], "]"}], "+", " ", 
    RowBox[{"SP", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "3", ",", "3"}], "}"}]}], "]"}], "+", " ", 
    RowBox[{"SP", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}], "]"}], "-", 
    RowBox[{"SP", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "2"}], "}"}]}], "]"}], "-", 
    RowBox[{"SP", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1", ",", "2"}], "}"}]}], "]"}], "-", 
    RowBox[{"SP", "[", 
     RowBox[{"3", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2", ",", "1"}], "}"}]}], "]"}]}], ")"}]}]], "Input",
 CellTags->"b:5.4.2"],

Cell["Check on the Entropy of the full system and Sub Entropies", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{"Entropy", "[", 
  StyleBox[
   SubscriptBox["\[Rho]", "GHZ"],
   FontSize->12], "]"}]], "Input",
 CellTags->"b:5.4.2"],

Cell["\<\
The density matrix of the subsystem [a,b] can be obtained readily, and its 
decomposition into products of Pauli matrices is explictly given\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Subsys", "[", 
   RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"Complement", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"a", ",", "b"}], "}"}]}], "]"}], ",", 
    StyleBox[
     SubscriptBox["\[Rho]", "GHZ"],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}]], "Input",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{"Subsys23", "=", 
  RowBox[{"Subsys", "[", 
   RowBox[{"2", ",", "3"}], "]"}]}]], "Input",
 CellTags->"b:5.4.2"],

Cell[BoxData[{
 StyleBox[
  RowBox[{"Subsys23", "=", 
   RowBox[{"Subsys", "[", 
    RowBox[{"2", ",", "3"}], "]"}]}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "0"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "0"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "2"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "3"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "3"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "2"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12], "\[IndentingNewLine]", 
 StyleBox[
  RowBox[{"Tr", "[", 
   RowBox[{"Subsys23", ".", 
    RowBox[{"SP", "[", 
     RowBox[{"2", ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "]"}],
  FontSize->12]}], "Input",
 CellTags->"b:5.4.2"],

Cell["The Entropy of the subsystem 23 is however:", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell[BoxData[
 RowBox[{"Entropy", "[", "Subsys23", "]"}]], "Input",
 CellTags->"b:5.4.2"],

Cell["\<\
It is simple to do the same game for the other subsystems, which can be \
checked to give the same 
result as this one.\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell["\<\
Finally we show the Sub Entropy for the single qubit density matrices: \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.2"],

Cell[BoxData[{
 RowBox[{"Subsys3", "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    StyleBox[
     SubscriptBox["\[Rho]", "GHZ"],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}], "\[IndentingNewLine]", 
 RowBox[{"Entropy", "[", "Subsys3", "]"}]}], "Input",
 CellTags->"b:5.4.2"],

Cell[BoxData[{
 RowBox[{"Subsys2", "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "3"}], "}"}], ",", 
    StyleBox[
     SubscriptBox["\[Rho]", "GHZ"],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}], "\[IndentingNewLine]", 
 RowBox[{"Entropy", "[", "Subsys2", "]"}]}], "Input",
 CellTags->"b:5.4.2"],

Cell[BoxData[{
 RowBox[{"Subsys1", "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"2", ",", "3"}], "}"}], ",", 
    StyleBox[
     SubscriptBox["\[Rho]", "GHZ"],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}], "\[IndentingNewLine]", 
 RowBox[{"Entropy", "[", "Subsys1", "]"}]}], "Input",
 CellTags->"b:5.4.2"]
}, Open  ]],

Cell[CellGroupData[{

Cell["d) Werner State Study", "Subsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:4", "b:5.4.3"}],

Cell["\<\
Werner state is used to study how a noisy entangled resource alters the \
efficacy of a quantum channel\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 1: The Werner state made of qubits 12  is built"
}], "Subsubsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:4", "b:5.4.3"}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
  "Build", " ", "the", " ", "Two", " ", "Qubit", " ", "Werner", "  ", 
   "density", " ", "matrix", "   ", 
   StyleBox["W",
    FontSize->12], "  ", 
   RowBox[{"(", " ", 
    RowBox[{"Noisy", " ", "Entangled", " ", "State", " ", "Resource"}], " ", 
    ")"}]}], " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
  "First", " ", "get", " ", "the", " ", "Bell", " ", "density", " ", 
   "matrix"}], " "}]}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[TextData[{
 StyleBox["The ",
  FontFamily->"Helvetica"],
 StyleBox["Bell states",
  FontFamily->"Helvetica",
  FontWeight->"Bold"],
 StyleBox[" are the following:\n",
  FontFamily->"Helvetica"],
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "00"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |00\[RightAngleBracket] + |11\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "01"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |01\[RightAngleBracket] + |10\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "10"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |00\[RightAngleBracket] - |11\[RightAngleBracket] )\n",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["B", "11"], "=", " ", 
    RowBox[{"1", "/", 
     SqrtBox["2"]}]}], TraditionalForm]]],
 "( |01\[RightAngleBracket] - |10\[RightAngleBracket] )"
}], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.3"],

Cell[TextData[StyleBox["They can all be constructed in the following way, \
first we build a Bell operator of the form:",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Bellop", "=", 
   RowBox[{
    RowBox[{"CNOT", "[", 
     RowBox[{"2", ",", "1", ",", "2"}], "]"}], ".", 
    RowBox[{"had", "[", 
     RowBox[{"2", ",", "1"}], "]"}]}], " "}]}]], "Input",
 CellTags->"b:5.4.3"],

Cell[TextData[StyleBox["Then we build the Bell density matrix",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   SubscriptBox["B", 
    RowBox[{"a_", ",", "b_"}]], ":=", 
   RowBox[{"Bellop", ".", 
    RowBox[{"(", 
     StyleBox[
      RowBox[{
       SubscriptBox["\[ScriptCapitalP]", 
        StyleBox["a",
         ScriptLevel->0]], "\[CircleTimes]", 
       SubscriptBox["\[ScriptCapitalP]", 
        StyleBox["b",
         ScriptLevel->0]]}],
      ScriptLevel->0], 
     StyleBox[")",
      ScriptLevel->0]}], ".", 
    StyleBox[
     RowBox[{"Adj", "[", "Bellop", "]"}],
     ScriptLevel->0], " "}]}]}]], "Input",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   SubscriptBox["B", 
    RowBox[{"0", ",", "0"}]], "\[IndentingNewLine]", 
   SubscriptBox["B", 
    RowBox[{"0", ",", "1"}]], "\[IndentingNewLine]", 
   SubscriptBox["B", 
    RowBox[{"1", ",", "0"}]], "\[IndentingNewLine]", 
   SubscriptBox["B", 
    RowBox[{"1", ",", "1"}]]}]}]], "Input",
 CellTags->"b:5.4.3"],

Cell[TextData[StyleBox["Then we build the Werner density matrix which adds a \
noisy density matrix to the Bell State density matrix with a parameter \
\[Lambda] that varies between 0 and 1;  1 being pure Bell entangled state, 0 \
being completely random or noisy.",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{
   SubscriptBox["W", 
    RowBox[{"a_", ",", "b_", ",", 
     StyleBox["\[Lambda]_",
      FontFamily->"Helvetica"]}]], ":=", 
   RowBox[{
    RowBox[{
     StyleBox["\[Lambda]",
      FontFamily->"Helvetica"], 
     StyleBox["   ",
      FontFamily->"Helvetica"], 
     RowBox[{"Bellop", ".", 
      RowBox[{"(", 
       StyleBox[
        RowBox[{
         SubscriptBox["\[ScriptCapitalP]", 
          StyleBox["a",
           ScriptLevel->0]], "\[CircleTimes]", 
         SubscriptBox["\[ScriptCapitalP]", 
          StyleBox["b",
           ScriptLevel->0]]}],
        ScriptLevel->0], 
       StyleBox[")",
        ScriptLevel->0]}], ".", 
      StyleBox[
       RowBox[{"Adj", "[", "Bellop", "]"}],
       ScriptLevel->0]}]}], " ", "+", " ", 
    RowBox[{
     RowBox[{"(", " ", 
      RowBox[{"1", "-", " ", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}], 
      StyleBox[")",
       FontFamily->"Helvetica"]}], 
     StyleBox["  ",
      FontFamily->"Helvetica"], 
     RowBox[{
      RowBox[{"(", " ", 
       RowBox[{
        SubscriptBox["\[Sigma]", "0"], "\[CircleTimes]", " ", 
        SubscriptBox["\[Sigma]", "0"]}], ")"}], "/", "4"}]}]}]}]}]], "Input",
 CellTags->"b:5.4.3"],

Cell[TextData[StyleBox["General Form of Werner density Matrix for 2 qubits;  \
and check Trace",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{"Simplify", "[", 
  SubscriptBox["W", 
   RowBox[{"a", ",", "b", ",", 
    StyleBox["\[Lambda]",
     FontFamily->"Helvetica"]}]], "]"}], "\[IndentingNewLine]", 
 RowBox[{" ", 
  RowBox[{"Simplify", "[", 
   RowBox[{"Tr", "[", 
    SubscriptBox["W", 
     RowBox[{"a", ",", "b", ",", 
      StyleBox["\[Lambda]",
       FontFamily->"Helvetica"]}]], 
    StyleBox["]",
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}]}], "Input",
 CellTags->"b:5.4.3"],

Cell[TextData[StyleBox["Particular cases of Werner density Matrix for 2 \
qubits with different starting Bell state ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{"Simplify", "[", " ", 
  SubscriptBox["W", 
   RowBox[{"0", ",", "0", ",", 
    StyleBox["\[Lambda]",
     FontFamily->"Helvetica"]}]], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", " ", 
  SubscriptBox["W", 
   RowBox[{"0", ",", "1", ",", 
    StyleBox["\[Lambda]",
     FontFamily->"Helvetica"]}]], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", " ", 
  SubscriptBox["W", 
   RowBox[{"1", ",", "0", ",", 
    StyleBox["\[Lambda]",
     FontFamily->"Helvetica"]}]], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", " ", 
  SubscriptBox["W", 
   RowBox[{"1", ",", "1", ",", 
    StyleBox["\[Lambda]",
     FontFamily->"Helvetica"]}]], "]"}]}], "Input",
 CellTags->"b:5.4.3"],

Cell[TextData[StyleBox["Check eigenvalues of Werner density Matrix for 2 \
qubits with different starting Bell state ",
 FontFamily->"Helvetica"]], "Text",
 FontFamily->"Courier New",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", 
    SubscriptBox["W", 
     RowBox[{"a", ",", "b", ",", 
      StyleBox["\[Lambda]",
       FontFamily->"Helvetica"]}]], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", 
    SubscriptBox["W", 
     RowBox[{"a", ",", "b", ",", 
      StyleBox["\[Lambda]",
       FontFamily->"Helvetica"]}]], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", 
    SubscriptBox["W", 
     RowBox[{"a", ",", "b", ",", 
      StyleBox["\[Lambda]",
       FontFamily->"Helvetica"]}]], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", 
    SubscriptBox["W", 
     RowBox[{"a", ",", "b", ",", 
      StyleBox["\[Lambda]",
       FontFamily->"Helvetica"]}]], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}]}], "Input",
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 2: Look at the Polarization and Tensor Polarization of the Werner \
state  "
}], "Subsubsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:4", "b:5.4.3"}],

Cell["\<\
Vector and tensor polarizations of Werner state  
Rank 2 Tensor polarizations for Werner state \
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"T", "[", 
    RowBox[{"i_", ",", "j_"}], "]"}], ":=", 
   RowBox[{"Tr", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       SubscriptBox["\[Sigma]", "i"], "\[CircleTimes]", 
       SubscriptBox["\[Sigma]", "j"]}], ")"}], ".", 
     StyleBox[
      SubscriptBox["W", 
       RowBox[{"a", ",", "b", ",", 
        StyleBox["\[Lambda]",
         FontFamily->"Helvetica"]}]],
      FontSize->12]}], 
    StyleBox[" ",
     FontSize->12], 
    StyleBox["]",
     FontSize->12]}]}], 
  StyleBox[";",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{
     StyleBox["P",
      FontSize->12], "W", 
     StyleBox["A",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"1", ",", "0"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"2", ",", "0"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"3", ",", "0"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   StyleBox[
    RowBox[{
     StyleBox["P",
      FontSize->12], "W", 
     StyleBox["B",
      FontSize->12]}]], 
   StyleBox["=",
    FontSize->12], 
   RowBox[{
    StyleBox["{",
     FontSize->12], 
    RowBox[{
     StyleBox[
      RowBox[{"T", "[", 
       RowBox[{"0", ",", "1"}], "]"}],
      FontSize->12], 
     StyleBox[",",
      FontSize->12], 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "2"}], "]"}], ",", 
     RowBox[{"T", "[", 
      RowBox[{"0", ",", "3"}], "]"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    StyleBox[
     RowBox[{"TW", 
      StyleBox["AB",
       FontSize->12]}]], 
    StyleBox["=",
     FontSize->12], 
    RowBox[{
     StyleBox["{",
      FontSize->12], 
     RowBox[{
      StyleBox["Table",
       FontSize->12], 
      StyleBox["[",
       FontSize->12], 
      RowBox[{
       StyleBox[
        RowBox[{"T", "[", 
         RowBox[{"i", ",", "j"}], "]"}],
        FontSize->12], 
       StyleBox[",",
        FontSize->12], 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "3"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "1", ",", "3"}], "}"}]}], "]"}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", "PWA", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", "PWB", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"Flatten", "[", 
   RowBox[{"TWAB", ",", "1"}], "]"}], "]"}]}], "Input",
 FontFamily->"Courier New",
 CellTags->"b:5.4.3"],

Cell["\<\
Vector polarizations of Werner state are zero 
Rank 2 Tensor polarizations for Werner state are diagonal\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell["Vector polarizations of Werner state are zero ", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell["Look at Purity and Entropy", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{
  StyleBox[
   RowBox[{
    StyleBox["Full",
     FontSize->12], "Simplify"}]], "[", 
  RowBox[{"Purity", "[", 
   SubscriptBox["W", 
    RowBox[{"a", ",", "b", ",", 
     StyleBox["\[Lambda]",
      FontFamily->"Helvetica"]}]], 
   StyleBox["]",
    FontSize->12]}], 
  StyleBox["]",
   FontSize->12]}], "\[IndentingNewLine]", 
 RowBox[{
  StyleBox[
   RowBox[{
    StyleBox["Full",
     FontSize->12], "Simplify"}]], "[", 
  RowBox[{"Entropy", "[", 
   SubscriptBox["W", 
    RowBox[{"a", ",", "b", ",", 
     StyleBox["\[Lambda]",
      FontFamily->"Helvetica"]}]], 
   StyleBox["]",
    FontSize->12]}], 
  StyleBox["]",
   FontSize->12]}]}], "Input",
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 3:  Structure of the Werner Density Matrix"
}], "Subsubsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:4", "b:5.4.3"}],

Cell["\<\
Reconstruct Density Matrix 
Note the Werner state has zero polarization for each qubit and a simple \
tensor polarization structure\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{"FullSimplify", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "/", "4"}], ")"}], "  ", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"i", "=", "0"}], "3"], "   ", 
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"j", "=", "0"}], "3"], "    ", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"i", ",", "j"}], "]"}], "*", 
      RowBox[{"(", 
       RowBox[{
        SubscriptBox["\[Sigma]", "i"], "\[CircleTimes]", 
        SubscriptBox["\[Sigma]", "j"]}], ")"}]}]}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"%", "-", 
   SubscriptBox["W", 
    RowBox[{"a", ",", "b", ",", 
     StyleBox["\[Lambda]",
      FontFamily->"Helvetica"]}]]}], "]"}]}], "Input",
 CellTags->"b:5.4.3"],

Cell[TextData[{
 " Werner Density Matrix  has Form\n",
 "= (1/4)  [ 1 + \[Lambda] ( ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"-", "1"}], ")"}], "a"], "  ", 
    RowBox[{"(", 
     RowBox[{
      SubscriptBox["\[Sigma]", "1"], "\[CircleTimes]", 
      SubscriptBox["\[Sigma]", "1"]}], ")"}]}], TraditionalForm]]],
 "   - ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}], 
    RowBox[{"a", "+", "b", " "}]], TraditionalForm]]],
 " ",
 Cell[BoxData[
  RowBox[{"  ", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["\[Sigma]", "2"], "\[CircleTimes]", 
     SubscriptBox["\[Sigma]", "2"]}], ")"}]}]],
  FontFamily->"Helvetica"],
 "  + ",
 Cell[BoxData[
  FormBox[
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"-", "1"}], ")"}], "b"], TraditionalForm]]],
 Cell[BoxData[
  RowBox[{"  ", 
   RowBox[{"(", 
    RowBox[{
     SubscriptBox["\[Sigma]", "3"], "\[CircleTimes]", 
     SubscriptBox["\[Sigma]", "3"]}], ")"}]}]],
  FontFamily->"Helvetica"],
 " ]"
}], "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{"reconstruct", "=", " ", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "/", "4"}], ")"}], "    ", 
   RowBox[{"(", "  ", 
    RowBox[{
     RowBox[{"SP", "[", 
      RowBox[{"2", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], "]"}], "  ", "+", 
     RowBox[{"\[Lambda]", 
      RowBox[{"(", " ", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", "a"}], "  ", 
         RowBox[{"SP", "[", 
          RowBox[{"2", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}]}], "]"}]}], "-", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", "a"}], "  ", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", "b"}], "   ", 
         RowBox[{"SP", "[", 
          RowBox[{"2", ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "2"}], "}"}]}], "]"}]}], "+", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"-", "1"}], ")"}], "^", "b"}], " ", 
         RowBox[{"SP", "[", 
          RowBox[{"2", ",", 
           RowBox[{"{", 
            RowBox[{"3", " ", ",", " ", "3"}], "}"}]}], "]"}]}]}], ")"}]}]}], 
    " ", ")"}]}]}], "\[IndentingNewLine]", 
 RowBox[{"Simplify", "[", 
  RowBox[{"reconstruct", "-", 
   SubscriptBox["W", 
    RowBox[{"a", ",", "b", ",", "\[Lambda]"}]]}], "]"}]}], "Input",
 CellTags->"b:5.4.3"]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[Cell[""], TraditionalForm]]]]], TraditionalForm]]],
 "Step 3: Look at the Entropy, Purity and Sub-entropy of the Werner state  "
}], "Subsubsection",
 CellFrame->True,
 FontFamily->"Times",
 CellTags->{"c:4", "b:5.4.3"}],

Cell["Check on Purity", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{"FullSimplify", "[", 
  RowBox[{"Purity", "[", 
   StyleBox[
    SubscriptBox["W", 
     RowBox[{"a", ",", "b", ",", 
      StyleBox["\[Lambda]",
       FontFamily->"Helvetica"]}]],
    FontSize->12], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Purity", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", "  ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Purity", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], "/.", "  ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Purity", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Purity", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}]}], "Input",
 CellTags->"b:5.4.3"],

Cell["Check on Entropy", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Entropy", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", "  ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Entropy", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], "/.", "  ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Entropy", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "->", "0"}]}], "}"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Entropy", "[", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12], "]"}], "]"}], " ", "/.", " ", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"a", "\[Rule]", "1"}], ",", " ", 
    RowBox[{"b", "\[Rule]", "1"}]}], "}"}]}]}], "Input",
 CellTags->"b:5.4.3"],

Cell["\<\
Prepare for Entropy versus \[Lambda] plot\
\>", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Ent", "[", 
   RowBox[{"x_", ",", "y_", ",", "z_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"Simplify", "[", 
    RowBox[{"Entropy", "[", 
     StyleBox[
      SubscriptBox["W", 
       RowBox[{"a", ",", "b", ",", 
        StyleBox["\[Lambda]",
         FontFamily->"Helvetica"]}]],
      FontSize->12], "]"}], "]"}], " ", "/.", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "x"}], ",", 
     RowBox[{"b", "\[Rule]", "y"}], ",", 
     RowBox[{"\[Lambda]", " ", "\[Rule]", "z"}]}], "}"}]}]}]], "Input",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"Ent", "[", 
     RowBox[{"0", ",", "0", ",", "s"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "0.0001`", ",", "0.99999`"}], "}"}]}], "]"}]], "Input",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"Ent", "[", 
     RowBox[{"0", ",", "1", ",", "s"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "0.0001`", ",", "0.99999`"}], "}"}]}], "]"}]], "Input",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"Ent", "[", 
     RowBox[{"1", ",", "0", ",", "s"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "0.0001`", ",", "0.99999`"}], "}"}]}], "]"}]], "Input",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"Ent", "[", 
     RowBox[{"1", ",", "1", ",", "s"}], "]"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"s", ",", "0.0001`", ",", "0.99999`"}], "}"}]}], "]"}]], "Input",
 CellTags->"b:5.4.3"],

Cell["Same plot for all Bell states cases.", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell["Look at Sub-system 2", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{"r2", "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", "1", "}"}], ",", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  StyleBox[
   RowBox[{
    RowBox[{"Tr", "[", 
     RowBox[{"r2", ".", 
      SubscriptBox["\[Sigma]", "1"]}], "]"}], ",", 
    RowBox[{"Tr", "[", 
     RowBox[{"r2", ".", 
      SubscriptBox["\[Sigma]", "2"]}], "]"}], ",", 
    RowBox[{"Tr", "[", 
     RowBox[{"r2", ".", 
      SubscriptBox["\[Sigma]", "3"]}], "]"}]}],
   FontSize->12], 
  StyleBox["}",
   FontSize->12]}]}], "Input",
 CellTags->"b:5.4.3"],

Cell["Entropy and Purity of system 2", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{"Entropy", "[", "r2", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Purity", "[", "r2", "]"}]}], "Input",
 CellTags->"b:5.4.3"],

Cell["Look at Sub-system 1", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{"r1", "=", 
  RowBox[{"PTr", "[", 
   RowBox[{
    RowBox[{"{", "2", "}"}], ",", 
    StyleBox[
     SubscriptBox["W", 
      RowBox[{"a", ",", "b", ",", 
       StyleBox["\[Lambda]",
        FontFamily->"Helvetica"]}]],
     FontSize->12]}], 
   StyleBox["]",
    FontSize->12]}]}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  StyleBox[
   RowBox[{
    RowBox[{"Tr", "[", 
     RowBox[{"r1", ".", 
      SubscriptBox["\[Sigma]", "1"]}], "]"}], ",", 
    RowBox[{"Tr", "[", 
     RowBox[{"r1", ".", 
      SubscriptBox["\[Sigma]", "2"]}], "]"}], ",", 
    RowBox[{"Tr", "[", 
     RowBox[{"r1", ".", 
      SubscriptBox["\[Sigma]", "3"]}], "]"}]}],
   FontSize->12], 
  StyleBox["}",
   FontSize->12]}]}], "Input",
 CellTags->"b:5.4.3"],

Cell["Entropy and Purity of system 1", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{"Entropy", "[", "r1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Purity", "[", "r1", "]"}]}], "Input",
 CellTags->"b:5.4.3"],

Cell["Eigenvalues of sub-systems", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", "r1", "]"}], "]"}], 
  "  "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FullSimplify", "[", 
   RowBox[{"Eigenvalues", "[", "r2", "]"}], "]"}], " "}]}], "Input",
 CellTags->"b:5.4.3"],

Cell["Double Check on Entropy of the Full Werner case", "Text",
 FontFamily->"Helvetica",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{"val", "=", 
  RowBox[{
   RowBox[{"FullSimplify", "[", 
    RowBox[{"Eigenvalues", "[", 
     StyleBox[
      SubscriptBox["W", 
       RowBox[{"a", ",", "b", ",", 
        StyleBox["\[Lambda]",
         FontFamily->"Helvetica"]}]],
      FontSize->12], "]"}], "]"}], " ", "/.", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "0"}], ",", " ", 
     RowBox[{"b", "->", "0"}]}], "}"}]}]}]], "Input",
 CellTags->"b:5.4.3"],

Cell[BoxData[{
 RowBox[{"val", "[", 
  RowBox[{"[", "1", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"val", "[", 
  RowBox[{"[", "2", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"val", "[", 
  RowBox[{"[", "3", "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"val", "[", 
  RowBox[{"[", "4", "]"}], "]"}]}], "Input",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{"entcheck", "=", 
  RowBox[{"FullSimplify", "[", 
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"val", "[", 
        RowBox[{"[", "1", "]"}], "]"}], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", 
         RowBox[{"val", "[", 
          RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"val", "[", 
        RowBox[{"[", "2", "]"}], "]"}], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", 
         RowBox[{"val", "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"val", "[", 
        RowBox[{"[", "3", "]"}], "]"}], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", 
         RowBox[{"val", "[", 
          RowBox[{"[", "3", "]"}], "]"}]}], "]"}]}], "+", 
      RowBox[{
       RowBox[{"val", "[", 
        RowBox[{"[", "4", "]"}], "]"}], " ", 
       RowBox[{"Log", "[", 
        RowBox[{"2", ",", 
         RowBox[{"val", "[", 
          RowBox[{"[", "4", "]"}], "]"}]}], "]"}]}]}], ")"}]}], 
   "]"}]}]], "Input",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"entcheck", ",", 
   RowBox[{"{", 
    RowBox[{"\[Lambda]", ",", "0.00001`", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellTags->"b:5.4.3"],

Cell[BoxData[
 RowBox[{"N", "[", 
  RowBox[{"Simplify", "[", 
   RowBox[{
    RowBox[{"Ent", "[", 
     RowBox[{"1", ",", "1", ",", "\[Lambda]"}], "]"}], "-", "entcheck"}], 
   "]"}], "]"}]], "Input",
 CellTags->"b:5.4.3"]
}, Open  ]]
}, Open  ]]
}, Closed]]
},
WindowToolbars->{},
CellGrouping->Manual,
WindowSize->{669, 559},
WindowMargins->{{65, Automatic}, {Automatic, 87}},
Visible->True,
PrintingCopies->1,
PrintingStartingPageNumber->1,
PrintingPageRange->{1, 32000},
PrintingOptions->{"Magnification"->1,
"PaperOrientation"->"Portrait",
"PaperSize"->{612, 792},
"PostScriptOutputFile":>FrontEnd`FileName[{"export", "home", "brunojd"}, 
  "t.ps", CharacterEncoding -> "WindowsANSI"]},
ShowSelection->True,
TaggingRules:>{
 "PaginationCache" -> {{2005, 8, 9, 3, 36, 18.585304`8.02174465349935}, {1, 1,
     1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 
    2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4,
     4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 
    5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 7, 7, 7, 7,
     7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 
    8, 8, 8, 8, 8, 8, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 
    10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 10, 11, 11, 11, 11, 11, 
    11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 12, 12, 12, 12, 12, 12, 12, 
    12, 12, 12, 12, 12, 12, 12, 12, 12, 13, 13, 13, 13, 13, 13, 13, 13, 13, 
    13, 13, 13, 13, 13, 13, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 14, 
    14, 14, 14}, Automatic}, "NextIndexingNumber" -> 5, 
  "IndexEntries" -> {{"i:1", "CNOT\t"}, {"i:2", "HALL"}, {
    "i:3", "bra", "Quantum Density package"}, {
    "i:4", "ket", "Quantum Density Package"}}},
CellLabelAutoDelete->True,
InputAliases->{"intt" -> RowBox[{"\[Integral]", 
     RowBox[{"\[SelectionPlaceholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "dintt" -> RowBox[{
     SubsuperscriptBox[
     "\[Integral]", "\[SelectionPlaceholder]", "\[Placeholder]"], 
     RowBox[{"\[Placeholder]", 
       RowBox[{"\[DifferentialD]", "\[Placeholder]"}]}]}], "sumt" -> RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "prodt" -> RowBox[{
     UnderoverscriptBox["\[Product]", 
      RowBox[{"\[SelectionPlaceholder]", "=", "\[Placeholder]"}], 
      "\[Placeholder]"], "\[Placeholder]"}], "dt" -> RowBox[{
     SubscriptBox["\[PartialD]", "\[Placeholder]"], " ", 
     "\[SelectionPlaceholder]"}], "notation" -> RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongLeftRightArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "notation>" -> 
  RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongRightArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "notation<" -> 
  RowBox[{"Notation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        " ", "\[DoubleLongLeftArrow]", " ", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "symb" -> RowBox[{"Symbolize", "[", 
     TagBox[
     "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"], 
     "]"}], "infixnotation" -> RowBox[{"InfixNotation", "[", 
     RowBox[{
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> "NotationTemplateStyle"],
        ",", "\[Placeholder]"}], "]"}], "addia" -> 
  RowBox[{"AddInputAlias", "[", 
     RowBox[{"\"\[Placeholder]\"", "\[Rule]", 
       TagBox[
       "\[Placeholder]", NotationBoxTag, TagStyle -> 
        "NotationTemplateStyle"]}], "]"}], "pattwraper" -> 
  TagBox["\[Placeholder]", NotationPatternTag, TagStyle -> 
    "NotationPatternWrapperStyle"], "madeboxeswraper" -> 
  TagBox["\[Placeholder]", NotationMadeBoxesTag, TagStyle -> 
    "NotationMadeBoxesWrapperStyle"]},
Magnification->1,
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit) (November 6, 2010)",
StyleDefinitions->"Classroom.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "c:1"->{
  Cell[545, 20, 56, 1, 50, "Title",
   CellTags->"c:1"]},
 "c:2"->{
  Cell[967, 37, 298, 7, 51, "Section",
   CellTags->{"c:2", "b:5.0"}]},
 "b:5.0"->{
  Cell[967, 37, 298, 7, 51, "Section",
   CellTags->{"c:2", "b:5.0"}],
  Cell[1268, 46, 381, 11, 78, "Text",
   CellTags->"b:5.0"],
  Cell[1652, 59, 179, 5, 44, "Input",
   CellTags->"b:5.0"],
  Cell[1834, 66, 172, 4, 22, "Text",
   CellTags->"b:5.0"],
  Cell[2009, 72, 131, 3, 46, "Input",
   CellTags->"b:5.0"],
  Cell[2143, 77, 161, 3, 22, "Text",
   CellTags->"b:5.0"],
  Cell[2307, 82, 110, 3, 46, "Input",
   CellTags->"b:5.0"],
  Cell[2420, 87, 209, 4, 22, "Text",
   CellTags->"b:5.0"],
  Cell[2654, 95, 68, 2, 44, "Input",
   CellTags->"b:5.0"],
  Cell[2725, 99, 68, 2, 44, "Input",
   CellTags->"b:5.0"],
  Cell[2808, 104, 267, 8, 24, "Text",
   CellTags->"b:5.0"]},
 "c:3"->{
  Cell[3112, 117, 75, 2, 31, "Section",
   CellTags->"c:3"]},
 "SingleQubitStates"->{
  Cell[3212, 123, 136, 3, 57, "Subsection",
   CellTags->{"SingleQubitStates", "c:4", "b:5.1.0"}]},
 "c:4"->{
  Cell[3212, 123, 136, 3, 57, "Subsection",
   CellTags->{"SingleQubitStates", "c:4", "b:5.1.0"}],
  Cell[76317, 2666, 105, 3, 57, "Subsection",
   CellTags->{"c:4", "b:5.4.2"}],
  Cell[95279, 3387, 114, 3, 57, "Subsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[95596, 3401, 280, 8, 49, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[103964, 3688, 308, 9, 49, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[108261, 3863, 275, 8, 49, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[112146, 4005, 301, 8, 49, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}]},
 "b:5.1.0"->{
  Cell[3212, 123, 136, 3, 57, "Subsection",
   CellTags->{"SingleQubitStates", "c:4", "b:5.1.0"}],
  Cell[3351, 128, 371, 11, 37, "Text",
   CellTags->"b:5.1.0"],
  Cell[3725, 141, 86, 2, 44, "Input",
   CellTags->"b:5.1.0"],
  Cell[3814, 145, 211, 4, 22, "Text",
   CellTags->"b:5.1.0"],
  Cell[4028, 151, 155, 3, 22, "Text",
   CellTags->"b:5.1.0"],
  Cell[4186, 156, 86, 2, 44, "Input",
   CellTags->"b:5.1.0"],
  Cell[4275, 160, 211, 4, 22, "Text",
   CellTags->"b:5.1.0"],
  Cell[4489, 166, 234, 4, 37, "Text",
   CellTags->"b:5.1.0"],
  Cell[4726, 172, 87, 2, 44, "Input",
   CellTags->{"i:4", "b:5.1.0"}],
  Cell[4816, 176, 87, 2, 44, "Input",
   CellTags->{"i:3", "b:5.1.0"}],
  Cell[4906, 180, 417, 15, 24, "Text",
   CellTags->"b:5.1.0"],
  Cell[5326, 197, 144, 4, 44, "Input",
   CellTags->"b:5.1.0"],
  Cell[5473, 203, 161, 3, 22, "Text",
   CellTags->"b:5.1.0"],
  Cell[5637, 208, 639, 19, 60, "Input",
   CellTags->"b:5.1.0"],
  Cell[6279, 229, 295, 10, 22, "Text",
   CellTags->"b:5.1.0"],
  Cell[6577, 241, 200, 4, 60, "Input",
   CellTags->"b:5.1.0"],
  Cell[6780, 247, 481, 14, 22, "Text",
   CellTags->"b:5.1.0"],
  Cell[7264, 263, 139, 3, 60, "Input",
   CellTags->"b:5.1.0"],
  Cell[7406, 268, 327, 10, 41, "Text",
   CellTags->"b:5.1.0"],
  Cell[7736, 280, 391, 12, 60, "Input",
   CellTags->"b:5.1.0"],
  Cell[8130, 294, 420, 11, 37, "Text",
   CellTags->"b:5.1.0"],
  Cell[8553, 307, 211, 7, 44, "Input",
   CellTags->"b:5.1.0"],
  Cell[8767, 316, 195, 5, 60, "Input",
   CellTags->"b:5.1.0"]},
 "i:4"->{
  Cell[4726, 172, 87, 2, 44, "Input",
   CellTags->{"i:4", "b:5.1.0"}]},
 "i:3"->{
  Cell[4816, 176, 87, 2, 44, "Input",
   CellTags->{"i:3", "b:5.1.0"}]},
 "c:5"->{
  Cell[8999, 326, 113, 3, 57, "Subsection",
   CellTags->{"c:5", "b:5.1.1"}]},
 "b:5.1.1"->{
  Cell[8999, 326, 113, 3, 57, "Subsection",
   CellTags->{"c:5", "b:5.1.1"}],
  Cell[9115, 331, 399, 12, 37, "Text",
   CellTags->"b:5.1.1"],
  Cell[9517, 345, 351, 9, 60, "Input",
   CellTags->"b:5.1.1"],
  Cell[9871, 356, 437, 12, 37, "Text",
   CellTags->"b:5.1.1"],
  Cell[10311, 370, 912, 33, 60, "Input",
   CellTags->"b:5.1.1"],
  Cell[11226, 405, 279, 5, 37, "Text",
   CellTags->"b:5.1.1"],
  Cell[11508, 412, 282, 8, 44, "Input",
   CellTags->"b:5.1.1"],
  Cell[11793, 422, 171, 4, 22, "Text",
   CellTags->"b:5.1.1"],
  Cell[11967, 428, 156, 4, 44, "Input",
   CellTags->"b:5.1.1"],
  Cell[12126, 434, 213, 8, 22, "Text",
   CellTags->"b:5.1.1"],
  Cell[12342, 444, 155, 3, 60, "Input",
   CellTags->"b:5.1.1"],
  Cell[12500, 449, 216, 4, 22, "Text",
   CellTags->"b:5.1.1"],
  Cell[12719, 455, 136, 4, 44, "Input",
   CellTags->"b:5.1.1"],
  Cell[12858, 461, 481, 15, 44, "Input",
   CellTags->"b:5.1.1"],
  Cell[13342, 478, 175, 4, 22, "Text",
   CellTags->"b:5.1.1"],
  Cell[13520, 484, 742, 22, 75, "Input",
   CellTags->"b:5.1.1"]},
 "c:6"->{
  Cell[14299, 511, 115, 3, 57, "Subsection",
   CellTags->{"c:6", "b:5.1.2"}]},
 "b:5.1.2"->{
  Cell[14299, 511, 115, 3, 57, "Subsection",
   CellTags->{"c:6", "b:5.1.2"}],
  Cell[14417, 516, 190, 4, 22, "Text",
   CellTags->"b:5.1.2"],
  Cell[14610, 522, 1074, 38, 162, "Text",
   CellTags->"b:5.1.2"],
  Cell[15687, 562, 207, 4, 22, "Text",
   CellTags->"b:5.1.2"],
  Cell[15897, 568, 250, 8, 44, "Input",
   CellTags->"b:5.1.2"],
  Cell[16150, 578, 126, 3, 22, "Text",
   CellTags->"b:5.1.2"],
  Cell[16279, 583, 573, 21, 47, "Input",
   CellTags->"b:5.1.2"],
  Cell[16855, 606, 338, 9, 39, "Text",
   CellTags->"b:5.1.2"],
  Cell[17196, 617, 345, 11, 37, "Text",
   CellTags->"b:5.1.2"],
  Cell[17544, 630, 323, 10, 44, "Input",
   CellTags->"b:5.1.2"],
  Cell[17870, 642, 159, 3, 22, "Text",
   CellTags->"b:5.1.2"],
  Cell[18032, 647, 687, 25, 44, "Input",
   CellTags->"b:5.1.2"],
  Cell[18722, 674, 203, 4, 22, "Text",
   CellTags->"b:5.1.2"],
  Cell[18928, 680, 1261, 45, 72, "Input",
   CellTags->"b:5.1.2"]},
 "c:7"->{
  Cell[20226, 730, 122, 3, 57, "Subsection",
   CellTags->{"c:7", "b:5.1.3"}]},
 "b:5.1.3"->{
  Cell[20226, 730, 122, 3, 57, "Subsection",
   CellTags->{"c:7", "b:5.1.3"}],
  Cell[20351, 735, 648, 15, 67, "Text",
   CellTags->"b:5.1.3"],
  Cell[21002, 752, 1195, 41, 75, "Input",
   CellTags->"b:5.1.3"],
  Cell[22200, 795, 387, 14, 22, "Text",
   CellTags->"b:5.1.3"],
  Cell[22612, 813, 461, 11, 105, "Input",
   CellTags->"b:5.1.3"],
  Cell[23076, 826, 191, 4, 22, "Text",
   CellTags->"b:5.1.3"],
  Cell[23270, 832, 1695, 59, 44, "Input",
   CellTags->"b:5.1.3"],
  Cell[24968, 893, 145, 3, 60, "Input",
   CellTags->"b:5.1.3"],
  Cell[25128, 899, 332, 6, 37, "Text",
   CellTags->"b:5.1.3"],
  Cell[25463, 907, 153, 5, 44, "Input",
   CellTags->"b:5.1.3"],
  Cell[25619, 914, 153, 5, 44, "Input",
   CellTags->"b:5.1.3"],
  Cell[25775, 921, 153, 5, 44, "Input",
   CellTags->"b:5.1.3"]},
 "c:8"->{
  Cell[25965, 931, 115, 3, 57, "Subsection",
   CellTags->{"c:8", "b:5.1.4"}]},
 "b:5.1.4"->{
  Cell[25965, 931, 115, 3, 57, "Subsection",
   CellTags->{"c:8", "b:5.1.4"}],
  Cell[26083, 936, 361, 13, 22, "Text",
   CellTags->"b:5.1.4"],
  Cell[26447, 951, 247, 5, 90, "Input",
   CellTags->"b:5.1.4"],
  Cell[26697, 958, 147, 3, 22, "Text",
   CellTags->"b:5.1.4"],
  Cell[26847, 963, 243, 5, 90, "Input",
   CellTags->"b:5.1.4"],
  Cell[27093, 970, 564, 19, 37, "Text",
   CellTags->"b:5.1.4"],
  Cell[27682, 993, 2077, 58, 125, "Input",
   CellTags->"b:5.1.4"],
  Cell[29762, 1053, 1591, 63, 50, "Text",
   CellTags->"b:5.1.4"],
  Cell[31368, 1119, 594, 17, 52, "Text",
   CellTags->"b:5.1.4"],
  Cell[31987, 1140, 365, 11, 75, "Input",
   CellTags->"b:5.1.4"],
  Cell[32355, 1153, 319, 8, 75, "Input",
   CellTags->"b:5.1.4"],
  Cell[32689, 1164, 309, 5, 37, "Text",
   CellTags->"b:5.1.4"],
  Cell[33001, 1171, 269, 9, 47, "Input",
   CellTags->"b:5.1.4"],
  Cell[33273, 1182, 164, 3, 22, "Text",
   CellTags->"b:5.1.4"],
  Cell[33440, 1187, 97, 1, 60, "Input",
   CellTags->"b:5.1.4"],
  Cell[33540, 1190, 1122, 39, 65, "Text",
   CellTags->"b:5.1.4"],
  Cell[34665, 1231, 217, 6, 44, "Input",
   CellTags->"b:5.1.4"],
  Cell[34885, 1239, 69, 2, 24, "Text",
   CellTags->"b:5.1.4"],
  Cell[34957, 1243, 341, 10, 44, "Input",
   CellTags->"b:5.1.4"],
  Cell[35301, 1255, 210, 6, 44, "Input",
   CellTags->"b:5.1.4"],
  Cell[35514, 1263, 139, 4, 44, "Input",
   CellTags->"b:5.1.4"],
  Cell[35656, 1269, 377, 14, 26, "Text",
   CellTags->"b:5.1.4"],
  Cell[36036, 1285, 357, 11, 44, "Input",
   CellTags->"b:5.1.4"],
  Cell[36396, 1298, 357, 11, 44, "Input",
   CellTags->"b:5.1.4"],
  Cell[36756, 1311, 156, 3, 22, "Text",
   CellTags->"b:5.1.4"]},
 "Quantum Gates"->{
  Cell[36961, 1320, 91, 2, 31, "Section",
   CellTags->{"Quantum Gates", "c:9"}]},
 "c:9"->{
  Cell[36961, 1320, 91, 2, 31, "Section",
   CellTags->{"Quantum Gates", "c:9"}]},
 "c:10"->{
  Cell[37621, 1346, 185, 4, 57, "Subsection",
   CellTags->{"c:10", "b:5.2.0"}]},
 "b:5.2.0"->{
  Cell[37621, 1346, 185, 4, 57, "Subsection",
   CellTags->{"c:10", "b:5.2.0"}],
  Cell[37809, 1352, 1207, 41, 107, "Text",
   CellTags->"b:5.2.0"],
  Cell[39041, 1397, 136, 4, 44, "Input",
   CellTags->"b:5.2.0"],
  Cell[39180, 1403, 131, 3, 22, "Text",
   CellTags->"b:5.2.0"],
  Cell[39314, 1408, 65, 1, 44, "Input",
   CellTags->"b:5.2.0"],
  Cell[39382, 1411, 170, 4, 22, "Text",
   CellTags->"b:5.2.0"],
  Cell[39577, 1419, 129, 4, 44, "Input",
   CellTags->"b:5.2.0"],
  Cell[39709, 1425, 135, 3, 22, "Text",
   CellTags->"b:5.2.0"],
  Cell[39847, 1430, 226, 7, 44, "Input",
   CellTags->"b:5.2.0"],
  Cell[40100, 1441, 398, 6, 52, "Text",
   CellTags->"b:5.2.0"],
  Cell[40501, 1449, 859, 26, 90, "Input",
   CellTags->"b:5.2.0"],
  Cell[41363, 1477, 429, 15, 22, "Text",
   CellTags->"b:5.2.0"],
  Cell[41795, 1494, 196, 5, 44, "Input",
   CellTags->{"i:2", "b:5.2.0"}],
  Cell[41994, 1501, 186, 4, 22, "Text",
   CellTags->"b:5.2.0"],
  Cell[42183, 1507, 426, 13, 75, "Input",
   CellTags->"b:5.2.0"],
  Cell[42612, 1522, 238, 4, 22, "Text",
   CellTags->"b:5.2.0"],
  Cell[42853, 1528, 492, 12, 60, "Input",
   CellTags->"b:5.2.0"],
  Cell[43348, 1542, 820, 27, 47, "Text",
   CellTags->"b:5.2.0"],
  Cell[44171, 1571, 109, 3, 44, "Input",
   CellTags->"b:5.2.0"],
  Cell[44283, 1576, 269, 11, 24, "Text",
   CellTags->"b:5.2.0"],
  Cell[44555, 1589, 229, 6, 60, "Input",
   CellTags->"b:5.2.0"]},
 "i:2"->{
  Cell[41795, 1494, 196, 5, 44, "Input",
   CellTags->{"i:2", "b:5.2.0"}]},
 "i:1"->{
  Cell[44821, 1600, 176, 4, 57, "Subsection",
   CellTags->{"i:1", "c:11", "b:5.2.1"}],
  Cell[47497, 1693, 174, 4, 57, "Subsection",
   CellTags->{"i:1", "c:12", "b:5.2.2"}],
  Cell[50901, 1801, 172, 4, 57, "Subsection",
   CellTags->{"i:1", "c:13", "b:5.2.3"}]},
 "c:11"->{
  Cell[44821, 1600, 176, 4, 57, "Subsection",
   CellTags->{"i:1", "c:11", "b:5.2.1"}]},
 "b:5.2.1"->{
  Cell[44821, 1600, 176, 4, 57, "Subsection",
   CellTags->{"i:1", "c:11", "b:5.2.1"}],
  Cell[45000, 1606, 714, 19, 54, "Text",
   CellTags->"b:5.2.1"],
  Cell[45717, 1627, 112, 3, 44, "Input",
   CellTags->"b:5.2.1"],
  Cell[45832, 1632, 334, 11, 22, "Text",
   CellTags->"b:5.2.1"],
  Cell[46169, 1645, 393, 11, 44, "Input",
   CellTags->"b:5.2.1"],
  Cell[46565, 1658, 222, 4, 22, "Text",
   CellTags->"b:5.2.1"],
  Cell[46790, 1664, 185, 5, 44, "Input",
   CellTags->"b:5.2.1"],
  Cell[46978, 1671, 348, 11, 37, "Text",
   CellTags->"b:5.2.1"],
  Cell[47329, 1684, 131, 4, 44, "Input",
   CellTags->"b:5.2.1"]},
 "c:12"->{
  Cell[47497, 1693, 174, 4, 57, "Subsection",
   CellTags->{"i:1", "c:12", "b:5.2.2"}]},
 "b:5.2.2"->{
  Cell[47497, 1693, 174, 4, 57, "Subsection",
   CellTags->{"i:1", "c:12", "b:5.2.2"}],
  Cell[47674, 1699, 193, 4, 22, "Text",
   CellTags->"b:5.2.2"],
  Cell[47870, 1705, 230, 6, 22, "Text",
   CellTags->"b:5.2.2"],
  Cell[48103, 1713, 334, 6, 49, "Text",
   CellTags->"b:5.2.2"],
  Cell[48440, 1721, 209, 5, 60, "Input",
   CellTags->"b:5.2.2"],
  Cell[48652, 1728, 310, 10, 22, "Text",
   CellTags->"b:5.2.2"],
  Cell[48965, 1740, 114, 3, 44, "Input",
   CellTags->"b:5.2.2"],
  Cell[49082, 1745, 266, 5, 37, "Text",
   CellTags->"b:5.2.2"],
  Cell[49351, 1752, 171, 4, 22, "Text",
   CellTags->"b:5.2.2"],
  Cell[49525, 1758, 432, 9, 22, "Text",
   CellTags->"b:5.2.2"],
  Cell[49960, 1769, 154, 3, 22, "Text",
   CellTags->"b:5.2.2"],
  Cell[50117, 1774, 184, 5, 44, "Input",
   CellTags->"b:5.2.2"],
  Cell[50304, 1781, 322, 6, 37, "Text",
   CellTags->"b:5.2.2"],
  Cell[50629, 1789, 235, 7, 44, "Input",
   CellTags->"b:5.2.2"]},
 "c:13"->{
  Cell[50901, 1801, 172, 4, 57, "Subsection",
   CellTags->{"i:1", "c:13", "b:5.2.3"}]},
 "b:5.2.3"->{
  Cell[50901, 1801, 172, 4, 57, "Subsection",
   CellTags->{"i:1", "c:13", "b:5.2.3"}],
  Cell[51076, 1807, 276, 5, 37, "Text",
   CellTags->"b:5.2.3"],
  Cell[51355, 1814, 1648, 62, 108, "Text",
   CellTags->"b:5.2.3"],
  Cell[53006, 1878, 133, 3, 44, "Input",
   CellTags->"b:5.2.3"],
  Cell[53142, 1883, 847, 29, 81, "Text",
   CellTags->"b:5.2.3"]},
 "Measurement"->{
  Cell[54038, 1918, 89, 2, 31, "Section",
   CellTags->{"Measurement", "c:14"}],
  Cell[68780, 2394, 90, 2, 31, "Section",
   CellTags->{"Measurement", "c:18"}]},
 "c:14"->{
  Cell[54038, 1918, 89, 2, 31, "Section",
   CellTags->{"Measurement", "c:14"}]},
 "Measurements"->{
  Cell[54152, 1924, 213, 5, 57, "Subsection",
   CellTags->{"Measurements", "c:15", "b:5.3.0"}],
  Cell[58441, 2060, 224, 5, 57, "Subsection",
   CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}]},
 "c:15"->{
  Cell[54152, 1924, 213, 5, 57, "Subsection",
   CellTags->{"Measurements", "c:15", "b:5.3.0"}]},
 "b:5.3.0"->{
  Cell[54152, 1924, 213, 5, 57, "Subsection",
   CellTags->{"Measurements", "c:15", "b:5.3.0"}],
  Cell[54368, 1931, 253, 5, 37, "Text",
   CellTags->"b:5.3.0"],
  Cell[54624, 1938, 350, 9, 39, "Text",
   CellTags->"b:5.3.0"],
  Cell[54977, 1949, 1076, 31, 60, "Input",
   CellTags->"b:5.3.0"],
  Cell[56056, 1982, 211, 4, 22, "Text",
   CellTags->"b:5.3.0"],
  Cell[56270, 1988, 489, 14, 47, "Input",
   CellTags->"b:5.3.0"],
  Cell[56762, 2004, 233, 4, 37, "Text",
   CellTags->"b:5.3.0"],
  Cell[56998, 2010, 529, 17, 50, "Input",
   CellTags->"b:5.3.0"],
  Cell[57530, 2029, 232, 4, 37, "Text",
   CellTags->"b:5.3.0"],
  Cell[57765, 2035, 223, 6, 60, "Input",
   CellTags->"b:5.3.0"],
  Cell[57991, 2043, 187, 4, 22, "Text",
   CellTags->"b:5.3.0"],
  Cell[58181, 2049, 223, 6, 60, "Input",
   CellTags->"b:5.3.0"]},
 "MeasureKet"->{
  Cell[58441, 2060, 224, 5, 57, "Subsection",
   CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}]},
 "c:16"->{
  Cell[58441, 2060, 224, 5, 57, "Subsection",
   CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}]},
 "b:5.3.1"->{
  Cell[58441, 2060, 224, 5, 57, "Subsection",
   CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}],
  Cell[58668, 2067, 173, 4, 22, "Text",
   CellTags->"b:5.3.1"],
  Cell[58844, 2073, 987, 28, 60, "Input",
   CellTags->"b:5.3.1"],
  Cell[59834, 2103, 195, 4, 22, "Text",
   CellTags->"b:5.3.1"],
  Cell[60032, 2109, 228, 4, 37, "Text",
   CellTags->"b:5.3.1"],
  Cell[60263, 2115, 309, 10, 44, "Input",
   CellTags->"b:5.3.1"],
  Cell[60575, 2127, 236, 4, 37, "Text",
   CellTags->"b:5.3.1"],
  Cell[60814, 2133, 103, 3, 44, "Input",
   CellTags->"b:5.3.1"],
  Cell[60920, 2138, 171, 4, 22, "Text",
   CellTags->"b:5.3.1"],
  Cell[61094, 2144, 264, 8, 44, "Input",
   CellTags->"b:5.3.1"],
  Cell[61361, 2154, 89, 2, 44, "Input",
   CellTags->"b:5.3.1"],
  Cell[61453, 2158, 171, 4, 22, "Text",
   CellTags->"b:5.3.1"]},
 "c:17"->{
  Cell[61661, 2167, 211, 5, 57, "Subsection",
   CellTags->{"c:17", "b:5.3.2"}]},
 "b:5.3.2"->{
  Cell[61661, 2167, 211, 5, 57, "Subsection",
   CellTags->{"c:17", "b:5.3.2"}],
  Cell[61875, 2174, 250, 7, 60, "Input",
   CellTags->"b:5.3.2"],
  Cell[62128, 2183, 202, 4, 22, "Text",
   CellTags->"b:5.3.2"],
  Cell[62333, 2189, 1220, 34, 90, "Input",
   CellTags->"b:5.3.2"],
  Cell[63556, 2225, 223, 4, 49, "Text",
   CellTags->"b:5.3.2"],
  Cell[63782, 2231, 608, 17, 47, "Input",
   CellTags->"b:5.3.2"],
  Cell[64393, 2250, 265, 8, 22, "Text",
   CellTags->"b:5.3.2"],
  Cell[64661, 2260, 233, 4, 37, "Text",
   CellTags->"b:5.3.2"],
  Cell[64897, 2266, 669, 20, 64, "Input",
   CellTags->"b:5.3.2"],
  Cell[65569, 2288, 282, 5, 49, "Text",
   CellTags->"b:5.3.2"],
  Cell[65854, 2295, 125, 3, 44, "Input",
   CellTags->"b:5.3.2"],
  Cell[65982, 2300, 462, 7, 103, "Text",
   CellTags->"b:5.3.2"],
  Cell[66447, 2309, 143, 3, 22, "Text",
   CellTags->"b:5.3.2"],
  Cell[66593, 2314, 549, 22, 28, "Text",
   CellTags->"b:5.3.2"],
  Cell[67145, 2338, 433, 13, 44, "Input",
   CellTags->"b:5.3.2"],
  Cell[67581, 2353, 469, 12, 60, "Input",
   CellTags->"b:5.3.2"],
  Cell[68053, 2367, 162, 4, 44, "Input",
   CellTags->"b:5.3.2"],
  Cell[68218, 2373, 263, 8, 44, "Input",
   CellTags->"b:5.3.2"],
  Cell[68484, 2383, 247, 5, 37, "Text",
   CellTags->"b:5.3.2"]},
 "c:18"->{
  Cell[68780, 2394, 90, 2, 31, "Section",
   CellTags->{"Measurement", "c:18"}]},
 "c:19"->{
  Cell[68895, 2400, 116, 3, 57, "Subsection",
   CellTags->{"c:19", "b:5.4.0"}]},
 "b:5.4.0"->{
  Cell[68895, 2400, 116, 3, 57, "Subsection",
   CellTags->{"c:19", "b:5.4.0"}],
  Cell[69014, 2405, 195, 4, 22, "Text",
   CellTags->"b:5.4.0"],
  Cell[69212, 2411, 750, 26, 52, "Text",
   CellTags->"b:5.4.0"],
  Cell[69965, 2439, 291, 9, 39, "Text",
   CellTags->"b:5.4.0"],
  Cell[70259, 2450, 670, 22, 75, "Input",
   CellTags->"b:5.4.0"],
  Cell[70932, 2474, 138, 3, 22, "Text",
   CellTags->"b:5.4.0"],
  Cell[71073, 2479, 279, 5, 90, "Input",
   CellTags->"b:5.4.0"],
  Cell[71355, 2486, 133, 3, 22, "Text",
   CellTags->"b:5.4.0"],
  Cell[71491, 2491, 1000, 32, 90, "Input",
   CellTags->"b:5.4.0"],
  Cell[72494, 2525, 248, 9, 24, "Text",
   CellTags->"b:5.4.0"]},
 "c:20"->{
  Cell[72779, 2539, 105, 3, 57, "Subsection",
   CellTags->{"c:20", "b:5.4.1"}]},
 "b:5.4.1"->{
  Cell[72779, 2539, 105, 3, 57, "Subsection",
   CellTags->{"c:20", "b:5.4.1"}],
  Cell[72887, 2544, 591, 22, 33, "Text",
   CellTags->"b:5.4.1"],
  Cell[73481, 2568, 155, 3, 60, "Input",
   CellTags->"b:5.4.1"],
  Cell[73639, 2573, 130, 3, 22, "Text",
   CellTags->"b:5.4.1"],
  Cell[73772, 2578, 213, 5, 60, "Input",
   CellTags->"b:5.4.1"],
  Cell[73988, 2585, 161, 3, 22, "Text",
   CellTags->"b:5.4.1"],
  Cell[74152, 2590, 116, 3, 44, "Input",
   CellTags->"b:5.4.1"],
  Cell[74271, 2595, 191, 4, 22, "Text",
   CellTags->"b:5.4.1"],
  Cell[74465, 2601, 866, 28, 75, "Input",
   CellTags->"b:5.4.1"],
  Cell[75334, 2631, 946, 30, 79, "Input",
   CellTags->"b:5.4.1"]},
 "b:5.4.2"->{
  Cell[76317, 2666, 105, 3, 57, "Subsection",
   CellTags->{"c:4", "b:5.4.2"}],
  Cell[76425, 2671, 186, 5, 22, "Text",
   CellTags->"b:5.4.2"],
  Cell[76614, 2678, 475, 16, 47, "Input",
   CellTags->"b:5.4.2"],
  Cell[77092, 2696, 115, 2, 22, "Text",
   CellTags->"b:5.4.2"],
  Cell[77210, 2700, 251, 7, 60, "Input",
   CellTags->"b:5.4.2"],
  Cell[77464, 2709, 84, 2, 44, "Input",
   CellTags->"b:5.4.2"],
  Cell[77551, 2713, 423, 13, 46, "Input",
   CellTags->"b:5.4.2"],
  Cell[77977, 2728, 385, 10, 22, "Text",
   CellTags->"b:5.4.2"],
  Cell[78365, 2740, 636, 22, 49, "Input",
   CellTags->"b:5.4.2"],
  Cell[79004, 2764, 99, 2, 22, "Text",
   CellTags->"b:5.4.2"],
  Cell[79106, 2768, 180, 7, 47, "Input",
   CellTags->"b:5.4.2"],
  Cell[79289, 2777, 341, 13, 65, "Input",
   CellTags->"b:5.4.2"],
  Cell[79633, 2792, 341, 13, 65, "Input",
   CellTags->"b:5.4.2"],
  Cell[79977, 2807, 341, 13, 65, "Input",
   CellTags->"b:5.4.2"],
  Cell[80321, 2822, 335, 9, 157, "Text",
   CellTags->"b:5.4.2"],
  Cell[80659, 2833, 268, 11, 47, "Input",
   CellTags->"b:5.4.2"],
  Cell[80930, 2846, 5446, 217, 299, "Input",
   CellTags->"b:5.4.2"],
  Cell[86379, 3065, 375, 9, 90, "Input",
   CellTags->"b:5.4.2"],
  Cell[86757, 3076, 102, 2, 22, "Text",
   CellTags->"b:5.4.2"],
  Cell[86862, 3080, 738, 23, 75, "Input",
   CellTags->"b:5.4.2"],
  Cell[87603, 3105, 119, 2, 22, "Text",
   CellTags->"b:5.4.2"],
  Cell[87725, 3109, 1235, 38, 75, "Input",
   CellTags->"b:5.4.2"],
  Cell[88963, 3149, 121, 2, 22, "Text",
   CellTags->"b:5.4.2"],
  Cell[89087, 3153, 142, 5, 44, "Input",
   CellTags->"b:5.4.2"],
  Cell[89232, 3160, 212, 5, 49, "Text",
   CellTags->"b:5.4.2"],
  Cell[89447, 3167, 468, 17, 44, "Input",
   CellTags->"b:5.4.2"],
  Cell[89918, 3186, 135, 4, 44, "Input",
   CellTags->"b:5.4.2"],
  Cell[90056, 3192, 3588, 126, 270, "Input",
   CellTags->"b:5.4.2"],
  Cell[93647, 3320, 107, 2, 22, "Text",
   CellTags->"b:5.4.2"],
  Cell[93757, 3324, 89, 2, 44, "Input",
   CellTags->"b:5.4.2"],
  Cell[93849, 3328, 191, 6, 49, "Text",
   CellTags->"b:5.4.2"],
  Cell[94043, 3336, 143, 4, 22, "Text",
   CellTags->"b:5.4.2"],
  Cell[94189, 3342, 349, 12, 60, "Input",
   CellTags->"b:5.4.2"],
  Cell[94541, 3356, 349, 12, 60, "Input",
   CellTags->"b:5.4.2"],
  Cell[94893, 3370, 349, 12, 60, "Input",
   CellTags->"b:5.4.2"]},
 "b:5.4.3"->{
  Cell[95279, 3387, 114, 3, 57, "Subsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[95396, 3392, 175, 5, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[95596, 3401, 280, 8, 49, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[95879, 3411, 501, 15, 38, "Text",
   CellTags->"b:5.4.3"],
  Cell[96383, 3428, 1074, 38, 162, "Text",
   CellTags->"b:5.4.3"],
  Cell[97460, 3468, 207, 4, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[97670, 3474, 250, 8, 44, "Input",
   CellTags->"b:5.4.3"],
  Cell[97923, 3484, 149, 3, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[98075, 3489, 573, 21, 47, "Input",
   CellTags->"b:5.4.3"],
  Cell[98651, 3512, 355, 11, 101, "Input",
   CellTags->"b:5.4.3"],
  Cell[99009, 3525, 352, 6, 52, "Text",
   CellTags->"b:5.4.3"],
  Cell[99364, 3533, 1247, 43, 47, "Input",
   CellTags->"b:5.4.3"],
  Cell[100614, 3578, 182, 4, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[100799, 3584, 487, 17, 70, "Input",
   CellTags->"b:5.4.3"],
  Cell[101289, 3603, 204, 4, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[101496, 3609, 727, 21, 110, "Input",
   CellTags->"b:5.4.3"],
  Cell[102226, 3632, 205, 4, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[102434, 3638, 1493, 45, 110, "Input",
   CellTags->"b:5.4.3"],
  Cell[103964, 3688, 308, 9, 49, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[104275, 3699, 167, 5, 49, "Text",
   CellTags->"b:5.4.3"],
  Cell[104445, 3706, 2689, 106, 173, "Input",
   CellTags->"b:5.4.3"],
  Cell[107137, 3814, 176, 5, 49, "Text",
   CellTags->"b:5.4.3"],
  Cell[107316, 3821, 110, 2, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[107429, 3825, 90, 2, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[107522, 3829, 702, 29, 70, "Input",
   CellTags->"b:5.4.3"],
  Cell[108261, 3863, 275, 8, 49, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[108539, 3873, 203, 6, 49, "Text",
   CellTags->"b:5.4.3"],
  Cell[108745, 3881, 775, 25, 98, "Input",
   CellTags->"b:5.4.3"],
  Cell[109523, 3908, 1114, 44, 49, "Text",
   CellTags->"b:5.4.3"],
  Cell[110640, 3954, 1469, 46, 124, "Input",
   CellTags->"b:5.4.3"],
  Cell[112146, 4005, 301, 8, 49, "Subsubsection",
   CellTags->{"c:4", "b:5.4.3"}],
  Cell[112450, 4015, 79, 2, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[112532, 4019, 1870, 61, 130, "Input",
   CellTags->"b:5.4.3"],
  Cell[114405, 4082, 80, 2, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[114488, 4086, 1626, 53, 110, "Input",
   CellTags->"b:5.4.3"],
  Cell[116117, 4141, 113, 4, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[116233, 4147, 574, 18, 50, "Input",
   CellTags->"b:5.4.3"],
  Cell[116810, 4167, 278, 8, 44, "Input",
   CellTags->"b:5.4.3"],
  Cell[117091, 4177, 278, 8, 44, "Input",
   CellTags->"b:5.4.3"],
  Cell[117372, 4187, 278, 8, 44, "Input",
   CellTags->"b:5.4.3"],
  Cell[117653, 4197, 278, 8, 44, "Input",
   CellTags->"b:5.4.3"],
  Cell[117934, 4207, 100, 2, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[118037, 4211, 84, 2, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[118124, 4215, 757, 28, 66, "Input",
   CellTags->"b:5.4.3"],
  Cell[118884, 4245, 94, 2, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[118981, 4249, 146, 3, 60, "Input",
   CellTags->"b:5.4.3"],
  Cell[119130, 4254, 84, 2, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[119217, 4258, 757, 28, 66, "Input",
   CellTags->"b:5.4.3"],
  Cell[119977, 4288, 94, 2, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[120074, 4292, 146, 3, 60, "Input",
   CellTags->"b:5.4.3"],
  Cell[120223, 4297, 90, 2, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[120316, 4301, 275, 8, 60, "Input",
   CellTags->"b:5.4.3"],
  Cell[120594, 4311, 111, 2, 22, "Text",
   CellTags->"b:5.4.3"],
  Cell[120708, 4315, 461, 15, 50, "Input",
   CellTags->"b:5.4.3"],
  Cell[121172, 4332, 343, 9, 90, "Input",
   CellTags->"b:5.4.3"],
  Cell[121518, 4343, 1103, 35, 90, "Input",
   CellTags->"b:5.4.3"],
  Cell[122624, 4380, 183, 5, 44, "Input",
   CellTags->"b:5.4.3"],
  Cell[122810, 4387, 222, 7, 44, "Input",
   CellTags->"b:5.4.3"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"c:1", 127367, 4493},
 {"c:2", 127435, 4496},
 {"b:5.0", 127519, 4499},
 {"c:3", 128206, 4522},
 {"SingleQubitStates", 128292, 4525},
 {"c:4", 128402, 4528},
 {"b:5.1.0", 129011, 4543},
 {"i:4", 130540, 4590},
 {"i:3", 130623, 4593},
 {"c:5", 130706, 4596},
 {"b:5.1.1", 130799, 4599},
 {"c:6", 131858, 4632},
 {"b:5.1.2", 131952, 4635},
 {"c:7", 132888, 4664},
 {"b:5.1.3", 132982, 4667},
 {"c:8", 133791, 4692},
 {"b:5.1.4", 133885, 4695},
 {"Quantum Gates", 135565, 4746},
 {"c:9", 135658, 4749},
 {"c:10", 135752, 4752},
 {"b:5.2.0", 135848, 4755},
 {"i:2", 137267, 4798},
 {"i:1", 137353, 4801},
 {"c:11", 137629, 4808},
 {"b:5.2.1", 137732, 4811},
 {"c:12", 138360, 4830},
 {"b:5.2.2", 138463, 4833},
 {"c:13", 139413, 4862},
 {"b:5.2.3", 139516, 4865},
 {"Measurement", 139888, 4876},
 {"c:14", 140062, 4881},
 {"Measurements", 140163, 4884},
 {"c:15", 140383, 4889},
 {"b:5.3.0", 140495, 4892},
 {"MeasureKet", 141334, 4917},
 {"c:16", 141457, 4920},
 {"b:5.3.1", 141583, 4923},
 {"c:17", 142427, 4948},
 {"b:5.3.2", 142523, 4951},
 {"c:18", 143803, 4990},
 {"c:19", 143896, 4993},
 {"b:5.4.0", 143992, 4996},
 {"c:20", 144677, 5017},
 {"b:5.4.1", 144773, 5020},
 {"b:5.4.2", 145462, 5041},
 {"b:5.4.3", 147810, 5112}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 56, 1, 50, "Title",
 CellTags->"c:1"],
Cell[604, 23, 43, 0, 34, "Subtitle"],
Cell[650, 25, 292, 8, 20, "Abstract"],
Cell[CellGroupData[{
Cell[967, 37, 298, 7, 51, "Section",
 CellTags->{"c:2", "b:5.0"}],
Cell[1268, 46, 381, 11, 78, "Text",
 CellTags->"b:5.0"],
Cell[1652, 59, 179, 5, 44, "Input",
 CellTags->"b:5.0"],
Cell[1834, 66, 172, 4, 22, "Text",
 CellTags->"b:5.0"],
Cell[2009, 72, 131, 3, 46, "Input",
 CellTags->"b:5.0"],
Cell[2143, 77, 161, 3, 22, "Text",
 CellTags->"b:5.0"],
Cell[2307, 82, 110, 3, 46, "Input",
 CellTags->"b:5.0"],
Cell[2420, 87, 209, 4, 22, "Text",
 CellTags->"b:5.0"],
Cell[CellGroupData[{
Cell[2654, 95, 68, 2, 44, "Input",
 CellTags->"b:5.0"],
Cell[2725, 99, 68, 2, 44, "Input",
 CellTags->"b:5.0"]
}, Open  ]],
Cell[2808, 104, 267, 8, 24, "Text",
 CellTags->"b:5.0"]
}, Closed]],
Cell[CellGroupData[{
Cell[3112, 117, 75, 2, 31, "Section",
 CellTags->"c:3"],
Cell[CellGroupData[{
Cell[3212, 123, 136, 3, 57, "Subsection",
 CellTags->{"SingleQubitStates", "c:4", "b:5.1.0"}],
Cell[3351, 128, 371, 11, 37, "Text",
 CellTags->"b:5.1.0"],
Cell[3725, 141, 86, 2, 44, "Input",
 CellTags->"b:5.1.0"],
Cell[3814, 145, 211, 4, 22, "Text",
 CellTags->"b:5.1.0"],
Cell[4028, 151, 155, 3, 22, "Text",
 CellTags->"b:5.1.0"],
Cell[4186, 156, 86, 2, 44, "Input",
 CellTags->"b:5.1.0"],
Cell[4275, 160, 211, 4, 22, "Text",
 CellTags->"b:5.1.0"],
Cell[4489, 166, 234, 4, 37, "Text",
 CellTags->"b:5.1.0"],
Cell[4726, 172, 87, 2, 44, "Input",
 CellTags->{"i:4", "b:5.1.0"}],
Cell[4816, 176, 87, 2, 44, "Input",
 CellTags->{"i:3", "b:5.1.0"}],
Cell[4906, 180, 417, 15, 24, "Text",
 CellTags->"b:5.1.0"],
Cell[5326, 197, 144, 4, 44, "Input",
 CellTags->"b:5.1.0"],
Cell[5473, 203, 161, 3, 22, "Text",
 CellTags->"b:5.1.0"],
Cell[5637, 208, 639, 19, 60, "Input",
 CellTags->"b:5.1.0"],
Cell[6279, 229, 295, 10, 22, "Text",
 CellTags->"b:5.1.0"],
Cell[6577, 241, 200, 4, 60, "Input",
 CellTags->"b:5.1.0"],
Cell[6780, 247, 481, 14, 22, "Text",
 CellTags->"b:5.1.0"],
Cell[7264, 263, 139, 3, 60, "Input",
 CellTags->"b:5.1.0"],
Cell[7406, 268, 327, 10, 41, "Text",
 CellTags->"b:5.1.0"],
Cell[7736, 280, 391, 12, 60, "Input",
 CellTags->"b:5.1.0"],
Cell[8130, 294, 420, 11, 37, "Text",
 CellTags->"b:5.1.0"],
Cell[8553, 307, 211, 7, 44, "Input",
 CellTags->"b:5.1.0"],
Cell[8767, 316, 195, 5, 60, "Input",
 CellTags->"b:5.1.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8999, 326, 113, 3, 57, "Subsection",
 CellTags->{"c:5", "b:5.1.1"}],
Cell[9115, 331, 399, 12, 37, "Text",
 CellTags->"b:5.1.1"],
Cell[9517, 345, 351, 9, 60, "Input",
 CellTags->"b:5.1.1"],
Cell[9871, 356, 437, 12, 37, "Text",
 CellTags->"b:5.1.1"],
Cell[10311, 370, 912, 33, 60, "Input",
 CellTags->"b:5.1.1"],
Cell[11226, 405, 279, 5, 37, "Text",
 CellTags->"b:5.1.1"],
Cell[11508, 412, 282, 8, 44, "Input",
 CellTags->"b:5.1.1"],
Cell[11793, 422, 171, 4, 22, "Text",
 CellTags->"b:5.1.1"],
Cell[11967, 428, 156, 4, 44, "Input",
 CellTags->"b:5.1.1"],
Cell[12126, 434, 213, 8, 22, "Text",
 CellTags->"b:5.1.1"],
Cell[12342, 444, 155, 3, 60, "Input",
 CellTags->"b:5.1.1"],
Cell[12500, 449, 216, 4, 22, "Text",
 CellTags->"b:5.1.1"],
Cell[12719, 455, 136, 4, 44, "Input",
 CellTags->"b:5.1.1"],
Cell[12858, 461, 481, 15, 44, "Input",
 CellTags->"b:5.1.1"],
Cell[13342, 478, 175, 4, 22, "Text",
 CellTags->"b:5.1.1"],
Cell[13520, 484, 742, 22, 75, "Input",
 CellTags->"b:5.1.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[14299, 511, 115, 3, 57, "Subsection",
 CellTags->{"c:6", "b:5.1.2"}],
Cell[14417, 516, 190, 4, 22, "Text",
 CellTags->"b:5.1.2"],
Cell[14610, 522, 1074, 38, 162, "Text",
 CellTags->"b:5.1.2"],
Cell[15687, 562, 207, 4, 22, "Text",
 CellTags->"b:5.1.2"],
Cell[15897, 568, 250, 8, 44, "Input",
 CellTags->"b:5.1.2"],
Cell[16150, 578, 126, 3, 22, "Text",
 CellTags->"b:5.1.2"],
Cell[16279, 583, 573, 21, 47, "Input",
 CellTags->"b:5.1.2"],
Cell[16855, 606, 338, 9, 39, "Text",
 CellTags->"b:5.1.2"],
Cell[17196, 617, 345, 11, 37, "Text",
 CellTags->"b:5.1.2"],
Cell[17544, 630, 323, 10, 44, "Input",
 CellTags->"b:5.1.2"],
Cell[17870, 642, 159, 3, 22, "Text",
 CellTags->"b:5.1.2"],
Cell[18032, 647, 687, 25, 44, "Input",
 CellTags->"b:5.1.2"],
Cell[18722, 674, 203, 4, 22, "Text",
 CellTags->"b:5.1.2"],
Cell[18928, 680, 1261, 45, 72, "Input",
 CellTags->"b:5.1.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[20226, 730, 122, 3, 57, "Subsection",
 CellTags->{"c:7", "b:5.1.3"}],
Cell[20351, 735, 648, 15, 67, "Text",
 CellTags->"b:5.1.3"],
Cell[21002, 752, 1195, 41, 75, "Input",
 CellTags->"b:5.1.3"],
Cell[22200, 795, 387, 14, 22, "Text",
 CellTags->"b:5.1.3"],
Cell[CellGroupData[{
Cell[22612, 813, 461, 11, 105, "Input",
 CellTags->"b:5.1.3"],
Cell[23076, 826, 191, 4, 22, "Text",
 CellTags->"b:5.1.3"],
Cell[23270, 832, 1695, 59, 44, "Input",
 CellTags->"b:5.1.3"],
Cell[24968, 893, 145, 3, 60, "Input",
 CellTags->"b:5.1.3"]
}, Open  ]],
Cell[25128, 899, 332, 6, 37, "Text",
 CellTags->"b:5.1.3"],
Cell[25463, 907, 153, 5, 44, "Input",
 CellTags->"b:5.1.3"],
Cell[25619, 914, 153, 5, 44, "Input",
 CellTags->"b:5.1.3"],
Cell[25775, 921, 153, 5, 44, "Input",
 CellTags->"b:5.1.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[25965, 931, 115, 3, 57, "Subsection",
 CellTags->{"c:8", "b:5.1.4"}],
Cell[26083, 936, 361, 13, 22, "Text",
 CellTags->"b:5.1.4"],
Cell[26447, 951, 247, 5, 90, "Input",
 CellTags->"b:5.1.4"],
Cell[26697, 958, 147, 3, 22, "Text",
 CellTags->"b:5.1.4"],
Cell[26847, 963, 243, 5, 90, "Input",
 CellTags->"b:5.1.4"],
Cell[27093, 970, 564, 19, 37, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[27682, 993, 2077, 58, 125, "Input",
 CellTags->"b:5.1.4"],
Cell[29762, 1053, 1591, 63, 50, "Text",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[31368, 1119, 594, 17, 52, "Text",
 CellTags->"b:5.1.4"],
Cell[CellGroupData[{
Cell[31987, 1140, 365, 11, 75, "Input",
 CellTags->"b:5.1.4"],
Cell[32355, 1153, 319, 8, 75, "Input",
 CellTags->"b:5.1.4"]
}, Open  ]],
Cell[32689, 1164, 309, 5, 37, "Text",
 CellTags->"b:5.1.4"],
Cell[33001, 1171, 269, 9, 47, "Input",
 CellTags->"b:5.1.4"],
Cell[33273, 1182, 164, 3, 22, "Text",
 CellTags->"b:5.1.4"],
Cell[33440, 1187, 97, 1, 60, "Input",
 CellTags->"b:5.1.4"],
Cell[33540, 1190, 1122, 39, 65, "Text",
 CellTags->"b:5.1.4"],
Cell[34665, 1231, 217, 6, 44, "Input",
 CellTags->"b:5.1.4"],
Cell[34885, 1239, 69, 2, 24, "Text",
 CellTags->"b:5.1.4"],
Cell[34957, 1243, 341, 10, 44, "Input",
 CellTags->"b:5.1.4"],
Cell[35301, 1255, 210, 6, 44, "Input",
 CellTags->"b:5.1.4"],
Cell[35514, 1263, 139, 4, 44, "Input",
 CellTags->"b:5.1.4"],
Cell[35656, 1269, 377, 14, 26, "Text",
 CellTags->"b:5.1.4"],
Cell[36036, 1285, 357, 11, 44, "Input",
 CellTags->"b:5.1.4"],
Cell[36396, 1298, 357, 11, 44, "Input",
 CellTags->"b:5.1.4"],
Cell[36756, 1311, 156, 3, 22, "Text",
 CellTags->"b:5.1.4"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[36961, 1320, 91, 2, 31, "Section",
 CellTags->{"Quantum Gates", "c:9"}],
Cell[37055, 1324, 227, 4, 22, "Text"],
Cell[37285, 1330, 311, 12, 26, "Text"],
Cell[CellGroupData[{
Cell[37621, 1346, 185, 4, 57, "Subsection",
 CellTags->{"c:10", "b:5.2.0"}],
Cell[37809, 1352, 1207, 41, 107, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[39041, 1397, 136, 4, 44, "Input",
 CellTags->"b:5.2.0"],
Cell[39180, 1403, 131, 3, 22, "Text",
 CellTags->"b:5.2.0"],
Cell[39314, 1408, 65, 1, 44, "Input",
 CellTags->"b:5.2.0"],
Cell[39382, 1411, 170, 4, 22, "Text",
 CellTags->"b:5.2.0"],
Cell[CellGroupData[{
Cell[39577, 1419, 129, 4, 44, "Input",
 CellTags->"b:5.2.0"],
Cell[39709, 1425, 135, 3, 22, "Text",
 CellTags->"b:5.2.0"],
Cell[39847, 1430, 226, 7, 44, "Input",
 CellTags->"b:5.2.0"]
}, Open  ]]
}, Open  ]],
Cell[40100, 1441, 398, 6, 52, "Text",
 CellTags->"b:5.2.0"],
Cell[40501, 1449, 859, 26, 90, "Input",
 CellTags->"b:5.2.0"],
Cell[41363, 1477, 429, 15, 22, "Text",
 CellTags->"b:5.2.0"],
Cell[41795, 1494, 196, 5, 44, "Input",
 CellTags->{"i:2", "b:5.2.0"}],
Cell[41994, 1501, 186, 4, 22, "Text",
 CellTags->"b:5.2.0"],
Cell[42183, 1507, 426, 13, 75, "Input",
 CellTags->"b:5.2.0"],
Cell[42612, 1522, 238, 4, 22, "Text",
 CellTags->"b:5.2.0"],
Cell[42853, 1528, 492, 12, 60, "Input",
 CellTags->"b:5.2.0"],
Cell[43348, 1542, 820, 27, 47, "Text",
 CellTags->"b:5.2.0"],
Cell[44171, 1571, 109, 3, 44, "Input",
 CellTags->"b:5.2.0"],
Cell[44283, 1576, 269, 11, 24, "Text",
 CellTags->"b:5.2.0"],
Cell[44555, 1589, 229, 6, 60, "Input",
 CellTags->"b:5.2.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[44821, 1600, 176, 4, 57, "Subsection",
 CellTags->{"i:1", "c:11", "b:5.2.1"}],
Cell[45000, 1606, 714, 19, 54, "Text",
 CellTags->"b:5.2.1"],
Cell[45717, 1627, 112, 3, 44, "Input",
 CellTags->"b:5.2.1"],
Cell[45832, 1632, 334, 11, 22, "Text",
 CellTags->"b:5.2.1"],
Cell[46169, 1645, 393, 11, 44, "Input",
 CellTags->"b:5.2.1"],
Cell[46565, 1658, 222, 4, 22, "Text",
 CellTags->"b:5.2.1"],
Cell[46790, 1664, 185, 5, 44, "Input",
 CellTags->"b:5.2.1"],
Cell[46978, 1671, 348, 11, 37, "Text",
 CellTags->"b:5.2.1"],
Cell[47329, 1684, 131, 4, 44, "Input",
 CellTags->"b:5.2.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47497, 1693, 174, 4, 57, "Subsection",
 CellTags->{"i:1", "c:12", "b:5.2.2"}],
Cell[47674, 1699, 193, 4, 22, "Text",
 CellTags->"b:5.2.2"],
Cell[47870, 1705, 230, 6, 22, "Text",
 CellTags->"b:5.2.2"],
Cell[48103, 1713, 334, 6, 49, "Text",
 CellTags->"b:5.2.2"],
Cell[48440, 1721, 209, 5, 60, "Input",
 CellTags->"b:5.2.2"],
Cell[48652, 1728, 310, 10, 22, "Text",
 CellTags->"b:5.2.2"],
Cell[48965, 1740, 114, 3, 44, "Input",
 CellTags->"b:5.2.2"],
Cell[49082, 1745, 266, 5, 37, "Text",
 CellTags->"b:5.2.2"],
Cell[49351, 1752, 171, 4, 22, "Text",
 CellTags->"b:5.2.2"],
Cell[49525, 1758, 432, 9, 22, "Text",
 CellTags->"b:5.2.2"],
Cell[49960, 1769, 154, 3, 22, "Text",
 CellTags->"b:5.2.2"],
Cell[50117, 1774, 184, 5, 44, "Input",
 CellTags->"b:5.2.2"],
Cell[50304, 1781, 322, 6, 37, "Text",
 CellTags->"b:5.2.2"],
Cell[50629, 1789, 235, 7, 44, "Input",
 CellTags->"b:5.2.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[50901, 1801, 172, 4, 57, "Subsection",
 CellTags->{"i:1", "c:13", "b:5.2.3"}],
Cell[51076, 1807, 276, 5, 37, "Text",
 CellTags->"b:5.2.3"],
Cell[51355, 1814, 1648, 62, 108, "Text",
 CellTags->"b:5.2.3"],
Cell[53006, 1878, 133, 3, 44, "Input",
 CellTags->"b:5.2.3"],
Cell[53142, 1883, 847, 29, 81, "Text",
 CellTags->"b:5.2.3"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[54038, 1918, 89, 2, 31, "Section",
 CellTags->{"Measurement", "c:14"}],
Cell[CellGroupData[{
Cell[54152, 1924, 213, 5, 57, "Subsection",
 CellTags->{"Measurements", "c:15", "b:5.3.0"}],
Cell[54368, 1931, 253, 5, 37, "Text",
 CellTags->"b:5.3.0"],
Cell[54624, 1938, 350, 9, 39, "Text",
 CellTags->"b:5.3.0"],
Cell[54977, 1949, 1076, 31, 60, "Input",
 CellTags->"b:5.3.0"],
Cell[56056, 1982, 211, 4, 22, "Text",
 CellTags->"b:5.3.0"],
Cell[56270, 1988, 489, 14, 47, "Input",
 CellTags->"b:5.3.0"],
Cell[56762, 2004, 233, 4, 37, "Text",
 CellTags->"b:5.3.0"],
Cell[56998, 2010, 529, 17, 50, "Input",
 CellTags->"b:5.3.0"],
Cell[57530, 2029, 232, 4, 37, "Text",
 CellTags->"b:5.3.0"],
Cell[57765, 2035, 223, 6, 60, "Input",
 CellTags->"b:5.3.0"],
Cell[57991, 2043, 187, 4, 22, "Text",
 CellTags->"b:5.3.0"],
Cell[58181, 2049, 223, 6, 60, "Input",
 CellTags->"b:5.3.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[58441, 2060, 224, 5, 57, "Subsection",
 CellTags->{"Measurements", "MeasureKet", "c:16", "b:5.3.1"}],
Cell[58668, 2067, 173, 4, 22, "Text",
 CellTags->"b:5.3.1"],
Cell[58844, 2073, 987, 28, 60, "Input",
 CellTags->"b:5.3.1"],
Cell[59834, 2103, 195, 4, 22, "Text",
 CellTags->"b:5.3.1"],
Cell[60032, 2109, 228, 4, 37, "Text",
 CellTags->"b:5.3.1"],
Cell[60263, 2115, 309, 10, 44, "Input",
 CellTags->"b:5.3.1"],
Cell[60575, 2127, 236, 4, 37, "Text",
 CellTags->"b:5.3.1"],
Cell[60814, 2133, 103, 3, 44, "Input",
 CellTags->"b:5.3.1"],
Cell[60920, 2138, 171, 4, 22, "Text",
 CellTags->"b:5.3.1"],
Cell[61094, 2144, 264, 8, 44, "Input",
 CellTags->"b:5.3.1"],
Cell[61361, 2154, 89, 2, 44, "Input",
 CellTags->"b:5.3.1"],
Cell[61453, 2158, 171, 4, 22, "Text",
 CellTags->"b:5.3.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[61661, 2167, 211, 5, 57, "Subsection",
 CellTags->{"c:17", "b:5.3.2"}],
Cell[61875, 2174, 250, 7, 60, "Input",
 CellTags->"b:5.3.2"],
Cell[62128, 2183, 202, 4, 22, "Text",
 CellTags->"b:5.3.2"],
Cell[62333, 2189, 1220, 34, 90, "Input",
 CellTags->"b:5.3.2"],
Cell[63556, 2225, 223, 4, 49, "Text",
 CellTags->"b:5.3.2"],
Cell[63782, 2231, 608, 17, 47, "Input",
 CellTags->"b:5.3.2"],
Cell[64393, 2250, 265, 8, 22, "Text",
 CellTags->"b:5.3.2"],
Cell[64661, 2260, 233, 4, 37, "Text",
 CellTags->"b:5.3.2"],
Cell[64897, 2266, 669, 20, 64, "Input",
 CellTags->"b:5.3.2"],
Cell[65569, 2288, 282, 5, 49, "Text",
 CellTags->"b:5.3.2"],
Cell[65854, 2295, 125, 3, 44, "Input",
 CellTags->"b:5.3.2"],
Cell[65982, 2300, 462, 7, 103, "Text",
 CellTags->"b:5.3.2"],
Cell[66447, 2309, 143, 3, 22, "Text",
 CellTags->"b:5.3.2"],
Cell[66593, 2314, 549, 22, 28, "Text",
 CellTags->"b:5.3.2"],
Cell[67145, 2338, 433, 13, 44, "Input",
 CellTags->"b:5.3.2"],
Cell[67581, 2353, 469, 12, 60, "Input",
 CellTags->"b:5.3.2"],
Cell[68053, 2367, 162, 4, 44, "Input",
 CellTags->"b:5.3.2"],
Cell[68218, 2373, 263, 8, 44, "Input",
 CellTags->"b:5.3.2"],
Cell[68484, 2383, 247, 5, 37, "Text",
 CellTags->"b:5.3.2"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[68780, 2394, 90, 2, 31, "Section",
 CellTags->{"Measurement", "c:18"}],
Cell[CellGroupData[{
Cell[68895, 2400, 116, 3, 57, "Subsection",
 CellTags->{"c:19", "b:5.4.0"}],
Cell[69014, 2405, 195, 4, 22, "Text",
 CellTags->"b:5.4.0"],
Cell[69212, 2411, 750, 26, 52, "Text",
 CellTags->"b:5.4.0"],
Cell[69965, 2439, 291, 9, 39, "Text",
 CellTags->"b:5.4.0"],
Cell[70259, 2450, 670, 22, 75, "Input",
 CellTags->"b:5.4.0"],
Cell[70932, 2474, 138, 3, 22, "Text",
 CellTags->"b:5.4.0"],
Cell[71073, 2479, 279, 5, 90, "Input",
 CellTags->"b:5.4.0"],
Cell[71355, 2486, 133, 3, 22, "Text",
 CellTags->"b:5.4.0"],
Cell[71491, 2491, 1000, 32, 90, "Input",
 CellTags->"b:5.4.0"],
Cell[72494, 2525, 248, 9, 24, "Text",
 CellTags->"b:5.4.0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[72779, 2539, 105, 3, 57, "Subsection",
 CellTags->{"c:20", "b:5.4.1"}],
Cell[72887, 2544, 591, 22, 33, "Text",
 CellTags->"b:5.4.1"],
Cell[73481, 2568, 155, 3, 60, "Input",
 CellTags->"b:5.4.1"],
Cell[73639, 2573, 130, 3, 22, "Text",
 CellTags->"b:5.4.1"],
Cell[73772, 2578, 213, 5, 60, "Input",
 CellTags->"b:5.4.1"],
Cell[73988, 2585, 161, 3, 22, "Text",
 CellTags->"b:5.4.1"],
Cell[74152, 2590, 116, 3, 44, "Input",
 CellTags->"b:5.4.1"],
Cell[74271, 2595, 191, 4, 22, "Text",
 CellTags->"b:5.4.1"],
Cell[74465, 2601, 866, 28, 75, "Input",
 CellTags->"b:5.4.1"],
Cell[75334, 2631, 946, 30, 79, "Input",
 CellTags->"b:5.4.1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76317, 2666, 105, 3, 57, "Subsection",
 CellTags->{"c:4", "b:5.4.2"}],
Cell[76425, 2671, 186, 5, 22, "Text",
 CellTags->"b:5.4.2"],
Cell[76614, 2678, 475, 16, 47, "Input",
 CellTags->"b:5.4.2"],
Cell[77092, 2696, 115, 2, 22, "Text",
 CellTags->"b:5.4.2"],
Cell[77210, 2700, 251, 7, 60, "Input",
 CellTags->"b:5.4.2"],
Cell[77464, 2709, 84, 2, 44, "Input",
 CellTags->"b:5.4.2"],
Cell[77551, 2713, 423, 13, 46, "Input",
 CellTags->"b:5.4.2"],
Cell[77977, 2728, 385, 10, 22, "Text",
 CellTags->"b:5.4.2"],
Cell[78365, 2740, 636, 22, 49, "Input",
 CellTags->"b:5.4.2"],
Cell[79004, 2764, 99, 2, 22, "Text",
 CellTags->"b:5.4.2"],
Cell[79106, 2768, 180, 7, 47, "Input",
 CellTags->"b:5.4.2"],
Cell[79289, 2777, 341, 13, 65, "Input",
 CellTags->"b:5.4.2"],
Cell[79633, 2792, 341, 13, 65, "Input",
 CellTags->"b:5.4.2"],
Cell[79977, 2807, 341, 13, 65, "Input",
 CellTags->"b:5.4.2"],
Cell[80321, 2822, 335, 9, 157, "Text",
 CellTags->"b:5.4.2"],
Cell[80659, 2833, 268, 11, 47, "Input",
 CellTags->"b:5.4.2"],
Cell[80930, 2846, 5446, 217, 299, "Input",
 CellTags->"b:5.4.2"],
Cell[86379, 3065, 375, 9, 90, "Input",
 CellTags->"b:5.4.2"],
Cell[86757, 3076, 102, 2, 22, "Text",
 CellTags->"b:5.4.2"],
Cell[86862, 3080, 738, 23, 75, "Input",
 CellTags->"b:5.4.2"],
Cell[87603, 3105, 119, 2, 22, "Text",
 CellTags->"b:5.4.2"],
Cell[87725, 3109, 1235, 38, 75, "Input",
 CellTags->"b:5.4.2"],
Cell[88963, 3149, 121, 2, 22, "Text",
 CellTags->"b:5.4.2"],
Cell[89087, 3153, 142, 5, 44, "Input",
 CellTags->"b:5.4.2"],
Cell[89232, 3160, 212, 5, 49, "Text",
 CellTags->"b:5.4.2"],
Cell[89447, 3167, 468, 17, 44, "Input",
 CellTags->"b:5.4.2"],
Cell[89918, 3186, 135, 4, 44, "Input",
 CellTags->"b:5.4.2"],
Cell[90056, 3192, 3588, 126, 270, "Input",
 CellTags->"b:5.4.2"],
Cell[93647, 3320, 107, 2, 22, "Text",
 CellTags->"b:5.4.2"],
Cell[93757, 3324, 89, 2, 44, "Input",
 CellTags->"b:5.4.2"],
Cell[93849, 3328, 191, 6, 49, "Text",
 CellTags->"b:5.4.2"],
Cell[94043, 3336, 143, 4, 22, "Text",
 CellTags->"b:5.4.2"],
Cell[94189, 3342, 349, 12, 60, "Input",
 CellTags->"b:5.4.2"],
Cell[94541, 3356, 349, 12, 60, "Input",
 CellTags->"b:5.4.2"],
Cell[94893, 3370, 349, 12, 60, "Input",
 CellTags->"b:5.4.2"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95279, 3387, 114, 3, 57, "Subsection",
 CellTags->{"c:4", "b:5.4.3"}],
Cell[95396, 3392, 175, 5, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[CellGroupData[{
Cell[95596, 3401, 280, 8, 49, "Subsubsection",
 CellTags->{"c:4", "b:5.4.3"}],
Cell[95879, 3411, 501, 15, 38, "Text",
 CellTags->"b:5.4.3"],
Cell[96383, 3428, 1074, 38, 162, "Text",
 CellTags->"b:5.4.3"],
Cell[97460, 3468, 207, 4, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[97670, 3474, 250, 8, 44, "Input",
 CellTags->"b:5.4.3"],
Cell[97923, 3484, 149, 3, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[98075, 3489, 573, 21, 47, "Input",
 CellTags->"b:5.4.3"],
Cell[98651, 3512, 355, 11, 101, "Input",
 CellTags->"b:5.4.3"],
Cell[99009, 3525, 352, 6, 52, "Text",
 CellTags->"b:5.4.3"],
Cell[99364, 3533, 1247, 43, 47, "Input",
 CellTags->"b:5.4.3"],
Cell[100614, 3578, 182, 4, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[100799, 3584, 487, 17, 70, "Input",
 CellTags->"b:5.4.3"],
Cell[101289, 3603, 204, 4, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[101496, 3609, 727, 21, 110, "Input",
 CellTags->"b:5.4.3"],
Cell[102226, 3632, 205, 4, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[102434, 3638, 1493, 45, 110, "Input",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[103964, 3688, 308, 9, 49, "Subsubsection",
 CellTags->{"c:4", "b:5.4.3"}],
Cell[104275, 3699, 167, 5, 49, "Text",
 CellTags->"b:5.4.3"],
Cell[104445, 3706, 2689, 106, 173, "Input",
 CellTags->"b:5.4.3"],
Cell[107137, 3814, 176, 5, 49, "Text",
 CellTags->"b:5.4.3"],
Cell[107316, 3821, 110, 2, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[107429, 3825, 90, 2, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[107522, 3829, 702, 29, 70, "Input",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[108261, 3863, 275, 8, 49, "Subsubsection",
 CellTags->{"c:4", "b:5.4.3"}],
Cell[108539, 3873, 203, 6, 49, "Text",
 CellTags->"b:5.4.3"],
Cell[108745, 3881, 775, 25, 98, "Input",
 CellTags->"b:5.4.3"],
Cell[109523, 3908, 1114, 44, 49, "Text",
 CellTags->"b:5.4.3"],
Cell[110640, 3954, 1469, 46, 124, "Input",
 CellTags->"b:5.4.3"]
}, Open  ]],
Cell[CellGroupData[{
Cell[112146, 4005, 301, 8, 49, "Subsubsection",
 CellTags->{"c:4", "b:5.4.3"}],
Cell[112450, 4015, 79, 2, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[112532, 4019, 1870, 61, 130, "Input",
 CellTags->"b:5.4.3"],
Cell[114405, 4082, 80, 2, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[114488, 4086, 1626, 53, 110, "Input",
 CellTags->"b:5.4.3"],
Cell[116117, 4141, 113, 4, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[116233, 4147, 574, 18, 50, "Input",
 CellTags->"b:5.4.3"],
Cell[116810, 4167, 278, 8, 44, "Input",
 CellTags->"b:5.4.3"],
Cell[117091, 4177, 278, 8, 44, "Input",
 CellTags->"b:5.4.3"],
Cell[117372, 4187, 278, 8, 44, "Input",
 CellTags->"b:5.4.3"],
Cell[117653, 4197, 278, 8, 44, "Input",
 CellTags->"b:5.4.3"],
Cell[117934, 4207, 100, 2, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[118037, 4211, 84, 2, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[118124, 4215, 757, 28, 66, "Input",
 CellTags->"b:5.4.3"],
Cell[118884, 4245, 94, 2, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[118981, 4249, 146, 3, 60, "Input",
 CellTags->"b:5.4.3"],
Cell[119130, 4254, 84, 2, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[119217, 4258, 757, 28, 66, "Input",
 CellTags->"b:5.4.3"],
Cell[119977, 4288, 94, 2, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[120074, 4292, 146, 3, 60, "Input",
 CellTags->"b:5.4.3"],
Cell[120223, 4297, 90, 2, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[120316, 4301, 275, 8, 60, "Input",
 CellTags->"b:5.4.3"],
Cell[120594, 4311, 111, 2, 22, "Text",
 CellTags->"b:5.4.3"],
Cell[120708, 4315, 461, 15, 50, "Input",
 CellTags->"b:5.4.3"],
Cell[121172, 4332, 343, 9, 90, "Input",
 CellTags->"b:5.4.3"],
Cell[121518, 4343, 1103, 35, 90, "Input",
 CellTags->"b:5.4.3"],
Cell[122624, 4380, 183, 5, 44, "Input",
 CellTags->"b:5.4.3"],
Cell[122810, 4387, 222, 7, 44, "Input",
 CellTags->"b:5.4.3"]
}, Open  ]]
}, Open  ]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
